#property indicator_separate_window
#property indicator_color1 DodgerBlue
#property indicator_color2 Lime
#property indicator_buffers 2
#property indicator_level3 0
#property indicator_levelcolor DimGray

extern int  TimeFrame       = 0;		
extern int  CCIPeriod       = 14;
extern int  MaPeriod        = 50;
extern int  MaType          = MODE_EMA;
extern bool Alert_MA        = true;
extern bool Alert_Level     = true;
extern int  _  = -90;
extern int  _ = 90;
extern bool AlertsMessage   = true;
extern bool AlertsSound     = false;
extern bool AlertsEmail     = false;
extern bool AlertsMobile    = false;
extern int  SignalBar       = 0;

int TimeBar;
double cci[],
       ema[],
       cciTF[],
       emaTF[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(4);
   
   SetIndexBuffer(0,cci);
   SetIndexBuffer(1,ema);
   
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1);
   
   SetIndexBuffer(2,cciTF);
   SetIndexBuffer(3,emaTF);
   
   SetLevelValue (0,_);
   SetLevelValue (1,_);
   
   IndicatorShortName("MTF CCI"+tf());
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   
//----
     int bbshift,limit,limitTF;
     limit=Bars;
     limitTF = iBars(Symbol(),TimeFrame);
     
     for(int i=0; i<limitTF; i++) cciTF[i] = iCCI(Symbol(),TimeFrame,CCIPeriod,PRICE_TYPICAL,i);
     for(int j=0; j<limitTF; j++) emaTF[j] = iMAOnArray(cciTF,0,MaPeriod,0,MaType,j);
     
     for(int t=0; t<limit; t++)
     {
         bbshift = iBarShift(Symbol(),TimeFrame,Time[t]);
         cci[t] = cciTF[bbshift];
         ema[t] = emaTF[bbshift];
     }
     
for(i=0; i<limitTF; i++) 
{    
if(AlertsMessage || AlertsEmail || AlertsMobile || AlertsSound)
 { 
 if(Alert_MA)
  {
   string message1 = ("CCI_EMA_MTF - "+Symbol()+" TF("+Period()+") - Trend Up");
   string message2 = ("CCI_EMA_MTF - "+Symbol()+" TF("+Period()+") - Trend Dn");
       
    if(TimeBar!=Time[0] && cci[SignalBar]>ema[SignalBar] && cci[SignalBar+1]<ema[SignalBar+1])
     { 
        if (AlertsMessage)Alert(message1);
        if (AlertsEmail)  SendMail(Symbol()+"CCI_EMA_MTF",message1);
        if (AlertsMobile) SendNotification(message1);
        if (AlertsSound)  PlaySound("alert2.wav");
        TimeBar=Time[0];
     }
    if(TimeBar!=Time[0] && cci[SignalBar]<ema[SignalBar] && cci[SignalBar+1]>ema[SignalBar+1])
     { 
        if (AlertsMessage)Alert(message2);
        if (AlertsEmail)  SendMail(Symbol()+"CCI_EMA_MTF",message2);
        if (AlertsMobile) SendNotification(message2);
        if (AlertsSound)  PlaySound("alert2.wav");
        TimeBar=Time[0];
    }
   }
   
  if(Alert_Level)
   {
   string message3 = ("CCI_EMA_MTF - "+Symbol()+" TF("+Period()+") -  : "+_);
   string message4 = ("CCI_EMA_MTF - "+Symbol()+" TF("+Period()+") -  : "+_);
       
    if(TimeBar!=Time[0] && cci[SignalBar]>_ && cci[SignalBar+1]<_)
     { 
        if (AlertsMessage)Alert(message3);
        if (AlertsEmail)  SendMail(Symbol()+"CCI_EMA_MTF",message3);
        if (AlertsMobile) SendNotification(message3);
        if (AlertsSound)  PlaySound("alert2.wav");
        TimeBar=Time[0];
     }
    if(TimeBar!=Time[0] && cci[SignalBar]<_ && cci[SignalBar+1]>_)
     { 
        if (AlertsMessage)Alert(message4);
        if (AlertsEmail)  SendMail(Symbol()+"CCI_EMA_MTF",message4);
        if (AlertsMobile) SendNotification(message4);
        if (AlertsSound)  PlaySound("alert2.wav");
        TimeBar=Time[0];
    }
   }   
 }
} 
//----
   return(0);
}
//+------------------------------------------------------------------+

string tf()
{
   switch(TimeFrame)
   {
      case PERIOD_M1: return("M(1)"); 
      case PERIOD_M5: return("M(5)");
      case PERIOD_M15: return("M(15)");
      case PERIOD_M30: return("M(30)");
      case PERIOD_H1: return("H(1)");
      case PERIOD_H4: return("H(4)");
      case PERIOD_D1: return("D(1)");
      case PERIOD_W1: return("W(1)");
      case PERIOD_MN1: return("MN(1)");
      default:return("Unknown timeframe");
   }
}