#property description	"Indicator alerts when candle size is larger than CandlePoint value for specified period"
#property strict

#property indicator_chart_window
#property indicator_buffers 0
#property indicator_plots 0


//+------------------------------------------------------------------+
//| Declaring Constants						|
//+------------------------------------------------------------------+
#define RESET 0			// Constant for returning to the terminal the command to recalculate the indicator

//+------------------------------------------------------------------+
//| Enumeration for the indication of operation						|
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| Input parameters of the indicator						|
//+------------------------------------------------------------------+
//--- Candle point size
input uint CandlePointM1 = 5;			// Minimum candle points for Period M1
input uint CandlePointM5 = 5;			// Minimum candle points for Period M5
// int timeFrame[] = {PERIOD_M1, PERIOD_M5, PERIOD_H1};
// string currencyPairs[] = {"AUDCAD", "AUDNZD", "AUDJPY", "AUDUSD"}

//+------------------------------------------------------------------+
//| Custom indicator initialisation function						|
//+------------------------------------------------------------------+
int OnInit()
{
return(INIT_SUCCEEDED);
}

//+------------------------------------------------------------------+
//| Deinitialisation						|
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
}

//+------------------------------------------------------------------+
//| Custom iteration function						|
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,	// The amount of history in bars on the current tick
const int prev_calculated,				// The amount of history in bars on the previous tick
const datetime &time[],
const double &open[],
const double &high[],
const double &low[],
const double &close[],
const long &tick_volume[],
const long &volume[],
const int &spread[])


//+------------------------------------------------------------------+
//| Candle size indicator						|
//+------------------------------------------------------------------+
{
//--- Checking the number of bars for sufficiency for calculating
if(Bars(Symbol(), Period())<1) return(RESET);
//--- Indexing of elements in arrays as in timeseries
ArraySetAsSeries(time,true);
int range;
static datetime alert_bar = 0; // used for one alert/bar
static datetime candleTime;
datetime iTime[1];
//--- Copy newly appeared data into arrays
{
double candleLow, candleHigh;
candleLow = iLow (Symbol(), Period(),0);
candleHigh = iHigh (Symbol(), Period(),0);
range=int((candleHigh-candleLow)/_Point);
}
if(CopyTime(Symbol(), Period(),Time[0],1,iTime)<=0) return(RESET);
if(iTime[0]!=candleTime)
{
candleTime=iTime[0];
}
if(alert_bar != Time[0])
	{
	if(Period()==PERIOD_M1)
		if(range>int(CandlePointM1))
		{
		Alert("",Symbol()," ",Period()," candle > ",CandlePointM1," points");
		alert_bar = Time[0];
		}
	if(Period()==PERIOD_M5)
		if(range>int(CandlePointM5))
		{
		Alert("",Symbol()," ",Period()," candle > ",CandlePointM5," points");
		alert_bar = Time[0];
		}
	}
return(rates_total);
}