#property description	"Indicator alerts when candle size is larger than CandlePoint value for specified period"
#property strict

#property indicator_chart_window
#property indicator_buffers 0
#property indicator_plots 0


//+------------------------------------------------------------------+
//| Declaring Constants						|
//+------------------------------------------------------------------+
#define RESET 0

//+------------------------------------------------------------------+
//| Enumeration for the indication of operation						|
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| Input parameters of the indicator						|
//+------------------------------------------------------------------+
//--- Candle point size
input uint CandlePointM1 = 5;			// Minimum candle points for Period M1
input uint CandlePointM5 = 5;			// Minimum candle points for Period M5
int timeFrame[] = {PERIOD_M1, PERIOD_M5, PERIOD_H1};
string currencyPairs[] = {"AUDCAD", "AUDNZD", "AUDJPY", "AUDUSD"}

//+------------------------------------------------------------------+
//| Custom indicator initialisation function						|
//+------------------------------------------------------------------+
int OnInit()
{
return(INIT_SUCCEEDED);
}

//+------------------------------------------------------------------+
//| Deinitialisation						|
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
}

//+------------------------------------------------------------------+
//| Custom iteration function						|
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
const int prev_calculated,
const datetime &time[],
const double &open[],
const double &high[],
const double &low[],
const double &close[],
const long &tick_volume[],
const long &volume[],
const int &spread[])


//+------------------------------------------------------------------+
//| Candle size indicator						|
//+------------------------------------------------------------------+
{
int range;
static datetime alert_bar = 0; // used for one alert/bar
datetime candleTime;

for(int i=0; i<3; i++)
	{
	for (int j=0 ;j<3 ;j++)
		{
		double candleLow, candleHigh;
		candleLow = iLow(currencyPairs[i],timeFrame[j],0);
		candleHigh = iHigh(currencyPairs[i],timeFrame[j],0);
		range = int((candleHigh-candleLow)/_Point);
		candleTime = iTime(currencyPairs[i],timeFrame[j],0);
		}
	}

if(CopyTime(currencyPairs[i],timeFrame[j],Time[0],1,iTime)<=0) return(RESET);
if(iTime[0]!=candleTime)
{
candleTime=iTime[0];
if (alert_bar != candleTime)
	{
		if (Period() == PERIOD_M1 && range>int(CandlePointM1))
		{
			Alert(Symbol(), " PERIOD_M1", " candle > ", CandlePointM1, " points");
			alert_bar = candleTime;
		}
		if (Period() == PERIOD_M5 && range>int(CandlePointM5))
		{
		Alert(Symbol(), " PERIOD_M5", " candle > ", CandlePointM5, " points");
		alert_bar = candleTime;
		}
	}
return(rates_total);
}
}