//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 clrLimeGreen
#property indicator_color2 clrPaleVioletRed
#property indicator_color3 clrPaleVioletRed
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property strict


extern ENUM_TIMEFRAMES   TimeFrame = PERIOD_CURRENT; // Time frame to use
extern int                MAPeriod  = 12;            // Average period
extern ENUM_APPLIED_PRICE MAPrice   = PRICE_CLOSE;   // Price
extern ENUM_MA_METHOD     MAMethod  = MODE_LWMA;     // Average method
extern int                MAShift   = 0;             // Shift

//
//
//
//
//

double ma[],maDa[],maDb[],slope[];
string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,ma);
   SetIndexBuffer(1,maDa);
   SetIndexBuffer(2,maDb);
   SetIndexBuffer(3,slope);
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99;
         TimeFrame         = MathMax(TimeFrame,_Period);
   for (int i=0; i<3; i++) SetIndexShift(i,MAShift*TimeFrame/_Period);
   return(0);
}

//
//
//
//
//

int start()
{ 
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit=MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { ma[0] = MathMin(limit+1,Bars-1); return(0); }
         if (TimeFrame!=_Period) limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/_Period));

   //
   //
   //
   //
   //
      
      if (slope[limit]==-1) CleanPoint(limit,maDa,maDb);
      for(int i = limit; i >= 0; i--)
      {  
         int y = iBarShift(NULL,TimeFrame,Time[i]);
         ma[i]    = iMA(NULL,TimeFrame,MAPeriod,0,MAMethod,MAPrice,y);   
         maDa[i]  = EMPTY_VALUE;
         maDb[i]  = EMPTY_VALUE;
         slope[i] = (i<Bars-1) ? (ma[i]>ma[i+1]) ? 1 : (ma[i]<ma[i+1]) ? -1 : slope[i+1] : 0;            
            if (slope[i] == -1)  PlotPoint(i,maDa,maDb,ma);
      }
      return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}