//+------------------------------------------------------------------+
//|                                                 Advanced_ADX.mq4 |
//|                              Copyright  2006, Eng. Waddah Attar |
//|                                          waddahattar@hotmail.com |
//+------------------------------------------------------------------+
#property copyright "Waddah Attar"
#property link      "waddahattar@hotmail.com"
//----
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  clrGreen
#property indicator_color2  clrRed
#property indicator_color3  clrDarkGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2

extern ENUM_TIMEFRAMES TimeFrame   = PERIOD_CURRENT;
extern int             ADXPeriod   = 13;
extern bool            Interpolate = true;
//----
double ExtBuffer1[];
double ExtBuffer2[];
double ExtBuffer3[];
double trend[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(4);
   SetIndexBuffer(0, ExtBuffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1, ExtBuffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2, ExtBuffer3);
   SetIndexBuffer(3, trend);
   indicatorFileName = WindowExpertName();
   returnBars        = (TimeFrame==-99);
   TimeFrame         = MathMax(TimeFrame,_Period);
   IndicatorShortName(timeFrameToString(TimeFrame)+" Advanced_ADX (" + ADXPeriod + ")");
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
{
   int i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { ExtBuffer1[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame==Period())
   {
     for(i=limit; i>=0; i--) 
     {
        ExtBuffer3[i] = iADX(NULL,0,ADXPeriod,PRICE_CLOSE,MODE_MAIN,i);
        double ADX1   = iADX(NULL,0,ADXPeriod,PRICE_CLOSE,MODE_PLUSDI,i);
        double ADX2   = iADX(NULL,0,ADXPeriod,PRICE_CLOSE,MODE_MINUSDI,i);
        ExtBuffer1[i] = EMPTY_VALUE;
        ExtBuffer2[i] = EMPTY_VALUE;
        trend[i]      = trend[i+1];
      
         if(ADX1 >= ADX2)  trend[i] = 1;
         if(ADX1 <  ADX2)  trend[i] =-1;
         if(trend[i] == 1) ExtBuffer1[i] = ExtBuffer3[i];
         if(trend[i] ==-1) ExtBuffer2[i] = ExtBuffer3[i];
     }
   return(0);
   }
   
   //
   //
   //
   //
   //
   

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         ExtBuffer1[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,ADXPeriod,0,y);
         ExtBuffer2[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,ADXPeriod,1,y);
         ExtBuffer3[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,ADXPeriod,2,y);
         
         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,TimeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               ExtBuffer3[i+k] = ExtBuffer3[i] + (ExtBuffer3[i+n] - ExtBuffer3[i]) *k/n;
               if (ExtBuffer1[i+k]!=EMPTY_VALUE) ExtBuffer1[i+k]=ExtBuffer3[i+k];
               if (ExtBuffer2[i+k]!=EMPTY_VALUE) ExtBuffer2[i+k]=ExtBuffer3[i+k];
            }
   }
   return(0);         
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}


