//+------------------------------------------------------------------+
//|                                                billko_volume.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
#property version   "1.00"
#property strict
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_plots   4
//--- plot Label1
#property indicator_label1  "New High Bar"
#property indicator_label2  "New Low Bar"
#property indicator_label3  "Outside Bar"
#property indicator_label4  "Inside Bar"

//--- input parameters
input color    NewHighBar=clrBlue;
input color    NewLowBar=clrRed;
input color    OutsideBar=clrGray;
input color    InsideBar=clrWhite;
//--- indicator buffers
double         NHB[];
double         NLB[];
double         OB[];
double         IB[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,NHB);
   SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,2,NewHighBar);
   SetIndexBuffer(1,NLB);
   SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY,2,NewLowBar);
   SetIndexBuffer(2,OB);
   SetIndexStyle(2,DRAW_HISTOGRAM,EMPTY,2,OutsideBar);
   SetIndexBuffer(3,IB);
   SetIndexStyle(3,DRAW_HISTOGRAM,EMPTY,2,InsideBar);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   int first,bar;
   if(prev_calculated>rates_total || prev_calculated<=0)
   {
      first=1;
   }
   else first=prev_calculated-1;

   for(bar=first; bar<rates_total && !IsStopped(); bar++)
   {
      if(high[bar]>high[bar+1])
      {
         if(low[bar]<low[bar+1])
            OB[bar]=(double)tick_volume[bar];
         else
            NHB[bar]=(double)tick_volume[bar];
      }
      else if(low[bar]<low[bar+1])
      {
         NLB[bar]=(double)tick_volume[bar];
      }
      else
      {
         IB[bar]=(double)tick_volume[bar];
      }
   }  
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
