
//+-------------------------------------------------------------------+
//|                                            Bollinger Bands %b.mq4 |
//|                       Copyright  2004, MetaQuotes Software Corp. |
//|                                         http://www.metaquotes.net |
//|                                     Modified by Alejandro Galindo |
//|                                                                   |
//|                                            You are free to use it |
//|                                                                   |
//|       If you want and if this work/modification is helpful to you |
//|              you can send me a PayPal donation to ag@elcactus.com |
//+-------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Yellow
#property indicator_color2 Red
#property indicator_color3 BlueViolet


#property indicator_style3 4
#property indicator_level1 1

#property indicator_levelcolor DarkSlateGray


//---- input parameters
extern int timeFrame=0;
extern int BBPeriod=20;
extern int StdDeviation=2;
extern int maPer=50,maMeth=MODE_EMA;

//---- buffers
double BLGBuffer[];
double ma[], lv[];
string indicatorFileName;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name; indicatorFileName = WindowExpertName();
//---- indicator line
   timeFrame = MathMax(timeFrame,Period());
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,BLGBuffer);
      SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ma);
   SetIndexBuffer(2,lv);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexShift(1,1);
   SetIndexShift(2,2);

//---- name for DataWindow and indicator subwindow label
   short_name="BBpB("+BBPeriod+","+StdDeviation+") |"+maPer+"|";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
   SetIndexLabel(1,"");
   SetIndexLabel(2,"");
//----
   SetIndexDrawBegin(0,maPer);
   SetIndexDrawBegin(1,maPer);
   SetIndexDrawBegin(2,maPer);



//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Momentum                                                         |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
            if (timeFrame!=Period())
            {
               limit = MathMin(MathMax(limit,3*timeFrame/Period()),Bars-1);
               for (int i=limit; i>=0; i--)
               {
                   int y = iBarShift(NULL,timeFrame,Time[i]);               
                     BLGBuffer[i] = iCustom(NULL,timeFrame,indicatorFileName,0,BBPeriod,StdDeviation,maPer,maMeth,0,y);
                     ma[i]        = iCustom(NULL,timeFrame,indicatorFileName,0,BBPeriod,StdDeviation,maPer,maMeth,1,y);
                     lv[i]        = 0.5;
               }    
               return(0);
            }
   if(counted_bars<1)
      for(i=1;i<=BBPeriod;i++) BLGBuffer[Bars-i]=0.0;
//----
   i=Bars-BBPeriod-1;
   if(counted_bars>=BBPeriod) i=Bars-counted_bars-1;
   while(i>=0)
     {
      BLGBuffer[i]=(Close[i]-iBands(NULL,0,BBPeriod,StdDeviation,0,0,MODE_HIGH,i))/(iBands(NULL,0,BBPeriod,StdDeviation,0,0,MODE_LOW,i)-iBands(NULL,0,BBPeriod,StdDeviation,0,0,MODE_HIGH,i));
      i--;
     }
   for(i=0; i<=Bars-counted_bars;i++)
   {
      ma[i] = iMAOnArray(BLGBuffer,0,maPer,0,maMeth,i);      
      lv[i]= 0.5;

   }
   

  
   return(0);
  }
//+------------------------------------------------------------------+