//+------------------------------------------------------------------+
//|                                 BW Market Facilitation Index.mq4 |
//|                                             Volumes |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//|                              AlexSilver http://viac.ru/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_separate_window
#property indicator_minimum 0
#property indicator_buffers 4
#property indicator_color1 Green 
#property indicator_color2 Blue 
#property indicator_color3 Gold 
#property indicator_color4 Red  

extern string note             = "turn on Alert = true; turn off = false";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = true;
extern bool   alertsNotify     = true;
extern bool   alertsEmail      = false;
extern string soundFile        = "alert2.wav";

//---- indicator buffers
double dMFIBuffer[];
double dMFIUpVUpBuffer[]; //  
double dMFIDownVDownBuffer[]; // 
double dMFIUpVDownBuffer[]; // 
double dMFIDownVUpBuffer[]; //  

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
   IndicatorBuffers(5);
   SetIndexBuffer(0,dMFIUpVUpBuffer);     SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,dMFIDownVDownBuffer); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,dMFIUpVDownBuffer);   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,dMFIDownVUpBuffer);   SetIndexStyle(3,DRAW_HISTOGRAM); 
   SetIndexBuffer(4,dMFIBuffer); 

   IndicatorShortName("BW MFI + Volumes"); 
   SetIndexLabel(0,"");
   SetIndexLabel(1,"");
   SetIndexLabel(2,"");
   SetIndexLabel(3,"");
   return(0);
  }
//+------------------------------------------------------------------+
//| BW Market Facilitation Index                                     |
//+------------------------------------------------------------------+
int start()
  {
   int    i,nLimit,nCountedBars;
//---- bars count that does not changed after last indicator launch.
   nCountedBars=IndicatorCounted();
//---- last counted bar will be recounted
   if(nCountedBars>0) nCountedBars--;
   nLimit=Bars-nCountedBars;
//---- Market Facilitation Index calculation
   for(i=0; i<nLimit; i++)
     if(i==0 && Volume[i]<Period()*1.5)
        dMFIBuffer[i]=0.0;
     else   
        dMFIBuffer[i]=(High[i]-Low[i])/(Volume[i]*Point);
//---- dispatch values between 4 buffers   
   for(i=nLimit-1; i>=0; i--)
    {
      dMFIUpVUpBuffer[i]     = EMPTY_VALUE;
      dMFIDownVDownBuffer[i] = EMPTY_VALUE;
      dMFIUpVDownBuffer[i]   = EMPTY_VALUE;
      dMFIDownVUpBuffer[i]   = EMPTY_VALUE;
     if((i!=nLimit-1&&bCompareDouble(dMFIBuffer[i],dMFIBuffer[i+1])&&dMFIBuffer[i]>dMFIBuffer[i+2]&&Volume[i]>Volume[i+1])||
        (i!=nLimit-1&&dMFIBuffer[i]>dMFIBuffer[i+1]&&Volume[i]==Volume[i+1]&&Volume[i]>Volume[i+2])||
        (i<nLimit-2&&dMFIBuffer[i]>dMFIBuffer[i+1]&&Volume[i]==Volume[i+1]&&Volume[i]==Volume[i+2]&&Volume[i]>Volume[i+3])||        
        (i!=nLimit-1&&bCompareDouble(dMFIBuffer[i],dMFIBuffer[i+1])&&dMFIBuffer[i]>dMFIBuffer[i+2]&&Volume[i]==Volume[i+1]&&Volume[i]>Volume[i+2])||
        (dMFIBuffer[i]>dMFIBuffer[i+1]&&Volume[i]>Volume[i+1])) 
       {
        dMFIUpVUpBuffer[i] = Volume[i];
        if (alertsOn) doAlert("Strong bullish signal");  
        continue;
       }
     if((i!=nLimit-1&&bCompareDouble(dMFIBuffer[i],dMFIBuffer[i+1])&&dMFIBuffer[i]<dMFIBuffer[i+2]&&Volume[i]<Volume[i+1])||
        (i!=nLimit-1&&dMFIBuffer[i]<dMFIBuffer[i+1]&&Volume[i]==Volume[i+1]&&Volume[i]<Volume[i+2])||
        (i<nLimit-2&&dMFIBuffer[i]<dMFIBuffer[i+1]&&Volume[i]==Volume[i+1]&&Volume[i]==Volume[i+2]&&Volume[i]<Volume[i+3])||        
        (i!=nLimit-1&&bCompareDouble(dMFIBuffer[i],dMFIBuffer[i+1])&&dMFIBuffer[i]<dMFIBuffer[i+2]&&Volume[i]==Volume[i+1]&&Volume[i]<Volume[i+2])||        
        (dMFIBuffer[i]<dMFIBuffer[i+1]&&Volume[i]<Volume[i+1])) 
       {
        dMFIDownVDownBuffer[i] = Volume[i];
        if (alertsOn) doAlert("Strong bearish signal");
        continue;         
       }
     if((i!=nLimit-1&&bCompareDouble(dMFIBuffer[i],dMFIBuffer[i+1])&&dMFIBuffer[i]>dMFIBuffer[i+2]&&Volume[i]<Volume[i+1])||
        (i!=nLimit-1&&dMFIBuffer[i]>dMFIBuffer[i+1]&&Volume[i]==Volume[i+1]&&Volume[i]<Volume[i+2])||
        (i<nLimit-2&&dMFIBuffer[i]>dMFIBuffer[i+1]&&Volume[i]==Volume[i+1]&&Volume[i]==Volume[i+2]&&Volume[i]<Volume[i+3])||        
        (i!=nLimit-1&&bCompareDouble(dMFIBuffer[i],dMFIBuffer[i+1])&&dMFIBuffer[i]>dMFIBuffer[i+2]&&Volume[i]==Volume[i+1]&&Volume[i]<Volume[i+2])||        
        (dMFIBuffer[i]>dMFIBuffer[i+1]&&Volume[i]<Volume[i+1])) 
       {
        
        dMFIUpVDownBuffer[i] = Volume[i];
        if (alertsOn) doAlert("Weak bullish signal");
        continue;         
       }
     if((i!=nLimit-1&&bCompareDouble(dMFIBuffer[i],dMFIBuffer[i+1])&&dMFIBuffer[i]<dMFIBuffer[i+2]&&Volume[i]>Volume[i+1])||
        (i!=nLimit-1&&dMFIBuffer[i]<dMFIBuffer[i+1]&&Volume[i]==Volume[i+1]&&Volume[i]>Volume[i+2])||
        (i<nLimit-2&&dMFIBuffer[i]<dMFIBuffer[i+1]&&Volume[i]==Volume[i+1]&&Volume[i]==Volume[i+2]&&Volume[i]>Volume[i+3])||        
        (i!=nLimit-1&&bCompareDouble(dMFIBuffer[i],dMFIBuffer[i+1])&&dMFIBuffer[i]<dMFIBuffer[i+2]&&Volume[i]==Volume[i+1]&&Volume[i]>Volume[i+2])||        
        (dMFIBuffer[i]<dMFIBuffer[i+1]&&Volume[i]>Volume[i+1])) 
       {
        dMFIDownVUpBuffer[i]=Volume[i];
        if (alertsOn) doAlert("Weak bearish signal");
        continue;         
       }        
    }                     
//---- done
   return(0);
  }
//+------------------------------------------------------------------+
 bool bCompareDouble (double dNumber1, double dNumber2)
    {
     bool bCompare=NormalizeDouble(dNumber1 - dNumber2,8) == 0;
     return(bCompare);
    }
    
//+------------------------------------------------------------------+
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," BW MFI+Volumes ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," BW MFI+Volumes " +" "+message));
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," BW MFI+Volumes "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}
 

