//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//----
#property indicator_chart_window
#property indicator_buffers    2
#property indicator_color1     DeepSkyBlue
#property indicator_color2     OrangeRed
#property indicator_width1     2
#property indicator_width2     2

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame = PERIOD_CURRENT;
extern int             CblPeriod = 13;

//
//
//
//
//

double cblHi[];
double cblLo[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0, cblHi); 
   SetIndexBuffer(1, cblLo); 
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame==-99;
   TimeFrame         = MathMax(TimeFrame,_Period);
   IndicatorShortName(timeFrameToString(TimeFrame)+" CountBack Line("+CblPeriod+")");
   return(0);
}
int deinit()
{
   return(0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars)  { cblHi[0] = limit+1; return(0); } 
         
   //
   //
   //
   //
   //
   
   if (TimeFrame == Period())
   {
     for(int i=limit; i>=0; i--)
     {
      double hi = High[iHighest(NULL,0,MODE_HIGH,CblPeriod,i)];
      double lo = Low [iLowest (NULL,0,MODE_LOW ,CblPeriod,i)];
      
      cblHi[i] = cblHi[i+1];
      while (true)
      {
         if (High[i]<hi)                              {                        break; }
         if (checkLowStrict(2,i) && checkLowRef(2,i)) { cblHi[i] = Low[i+2];   break; }
         if (checkLowStrict(3,i) && checkLowRef(3,i)) { cblHi[i] = Low[i+3];   break; }
         if (checkLowStrict(4,i) && checkLowRef(4,i)) { cblHi[i] = Low[i+4];   break; }
         if (checkLowStrict(5,i) && checkLowRef(5,i)) { cblHi[i] = Low[i+5];   break; }
            break;
      }         
      cblLo[i] = cblLo[i+1];
      while (true)
      {
         if (Low[i]>lo)                                 {                         break; }
         if (checkHighStrict(2,i) && checkHighRef(2,i)) { cblLo[i] = High[i+2];   break; }
         if (checkHighStrict(3,i) && checkHighRef(3,i)) { cblLo[i] = High[i+3];   break; }
         if (checkHighStrict(4,i) && checkHighRef(4,i)) { cblLo[i] = High[i+4];   break; }
         if (checkHighStrict(5,i) && checkHighRef(5,i)) { cblLo[i] = High[i+5];   break; }
            break;
      }         
   }
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         cblHi[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,CblPeriod,0,y);
         cblLo[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,CblPeriod,1,y);
   }      
return(0);   
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

bool checkLowStrict(int count, int i) { for (int k=count-1; k>=0; k--) if (Low[i+count] >= Low[i+k]) break;  return(k==-1); }
bool checkLowRef   (int count, int i) { for (int k=count-1; k> 0; k--) if (Low[i+k]     <  Low[i])   break;  return(k > 0); }

bool checkHighStrict(int count, int i) { for (int k=count-1; k>=0; k--) if (High[i+count] <= High[i+k]) break;  return(k==-1); }
bool checkHighRef   (int count, int i) { for (int k=count-1; k> 0; k--) if (High[i+k]     >  High[i])   break;  return(k > 0); }

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
