
#property copyright "http://dmffx.com"
#property link      "http://dmffx.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 DarkGray
#property indicator_color2 Red
#property indicator_color3 Yellow

//---- input parameters
extern   int      ForcePeriod=14;
extern   int      ForceMethod=0;
extern   int      ForcePrice=0;
extern   int      ForceShift=0; 
extern   int      SmPeriod=14;
extern   int      SmMethod=0;
extern   int      SmShift=0; 
extern   int      SgPeriod=14;
extern   int      SgMethod=0;
extern   int      SgShift=0;
extern   double   Level_1_Value=5;
extern   double   Level_2_Value=10;
extern   double   Level_3_Value=15;      
extern   color    Level_1_Color=RoyalBlue;
extern   color    Level_2_Color=Green;
extern   color    Level_3_Color=Chocolate;   
extern   bool     TesterMode=false; 

//---- buffers
double source[];
double main[];
double signal[];

string ShortName="DS Force";
string InIndexLabelName="DS Force";
string ObjPref="DS_Force";
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,source);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,main);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,signal);
   
   SetIndexShift(0,ForceShift);
   SetIndexShift(1,ForceShift+SmShift);   
   SetIndexShift(2,ForceShift+SmShift+SgShift);     
   
   SetIndexLabel(0,InIndexLabelName+" Source");
   SetIndexLabel(1,InIndexLabelName+" Main");   
   SetIndexLabel(2,InIndexLabelName+" Signal");
      
   IndicatorDigits(2);
   
   IndicatorShortName(ShortName);
   
   SetIndexDrawBegin(0,ForcePeriod);
   SetIndexDrawBegin(1,ForcePeriod+fMADrawBegin(SmPeriod,SmMethod));  
   SetIndexDrawBegin(2,ForcePeriod+fMADrawBegin(SmPeriod,SmMethod)+fMADrawBegin(SgPeriod,SgMethod));      
   
//----
   return(0);
  }
int fMADrawBegin(int aPeriod,int aMethod){
      switch(aMethod){
         case 1: return(10*aPeriod);
         case 2: return(20*aPeriod);      
      }
   return(aPeriod);    
}
  
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
      fObjDeleteByPrefix(ObjPref);
//----
   return(0);
  }
void fObjDeleteByPrefix(string aPrefix){
   for(int i=ObjectsTotal()-1;i>=0;i--){
      if(StringFind(ObjectName(i),aPrefix,0)==0){
         ObjectDelete(ObjectName(i));
      }
   }
}
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){

         int limit=Bars-IndicatorCounted();

            for(int i=limit-1;i>=0;i--){
               source[i]=iForce(NULL,0,ForcePeriod,ForceMethod,ForcePrice,i);
            }
            for(i=limit-1;i>=0;i--){
               main[i]=iMAOnArray(source,0,SmPeriod,0,SmMethod,i);
            }            
            for(  i=limit-1;i>=0;i--){
               signal[i]=iMAOnArray(main,0,SgPeriod,0,SgMethod,i);
            } 
            if(TesterMode){
               return(0);
            }
         fObjHLine(ObjPref+"_1p",Level_1_Value,Level_1_Color,1,WindowFind(ShortName),2,true);
         fObjHLine(ObjPref+"_2p",Level_2_Value,Level_2_Color,1,WindowFind(ShortName),2,true);           
         fObjHLine(ObjPref+"_3p",Level_3_Value,Level_3_Color,1,WindowFind(ShortName),2,true); 
         fObjHLine(ObjPref+"_1m",-Level_1_Value,Level_1_Color,1,WindowFind(ShortName),2,true);
         fObjHLine(ObjPref+"_2m",-Level_2_Value,Level_2_Color,1,WindowFind(ShortName),2,true);           
         fObjHLine(ObjPref+"_3m",-Level_3_Value,Level_3_Color,1,WindowFind(ShortName),2,true);  
         
        
                            
   return(0);
  }
//+------------------------------------------------------------------+

void fObjHLine(
   string aObjectName,  // 1 
   double aPrice_1,     // 2 
   color aColor=Red,    // 3 
   int aWidth=1,        // 4 
   int aWindowNumber=0, // 5 
   int aStyle=0,        // 6 0-STYLE_SOLID, 1-STYLE_DASH, 2-STYLE_DOT, 3-STYLE_DASHDOT, 4-STYLE_DASHDOTDOT
   bool aBack=false     // 7 
   ){
   
   // fHLine("",Close[1]);
   // fHLine("",Close[1],Red,1,0,STYLE_SOLID,false);
   
      if(ObjectFind(aObjectName)!=aWindowNumber){
         ObjectCreate(aObjectName,OBJ_HLINE,aWindowNumber,0,aPrice_1);
      }      
   ObjectSet(aObjectName,OBJPROP_PRICE1,aPrice_1);   
   ObjectSet(aObjectName,OBJPROP_COLOR,aColor);
   ObjectSet(aObjectName,OBJPROP_WIDTH,aWidth);
   ObjectSet(aObjectName,OBJPROP_BACK,aBack);   
   ObjectSet(aObjectName,OBJPROP_STYLE,aStyle);            
}

