#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red

extern int  Length = 20;

double      smooth[];
double      coef[];
double      ExtMapBuffer[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0,ExtMapBuffer);
   SetIndexBuffer(1,smooth);
   ArrayResize(coef,Length);
   IndicatorShortName("Ehlers("+Length+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--) 
   {
      smooth[i]=(Close[i] + 2*Close[i+1] + 2*Close[i+2] + Close[i+3]) / 6;
      for(int count=0;count<Length; count++)
      {
        double distance=0;
        for(int lookback=1; lookback<Length; lookback++)
            distance   += (smooth[i+count]-smooth[i+count+lookback])*(smooth[i+count]-smooth[i+count+lookback]);
            coef[count] = distance;
      }
      double num = 0, sumcoef = 0;
      for(count=0;count<Length;count++)
      {
         num     += coef[count]*smooth[i+count];
         sumcoef += coef[count];
      }
      if (sumcoef != 0) ExtMapBuffer[i] = num / sumcoef;
   }
   return(0);
}