#property indicator_chart_window

#property indicator_buffers 7

#property indicator_color1 Gold
#property indicator_color2 Brown
#property indicator_color3 Green
#property indicator_color4 Silver
#property indicator_color5 DimGray
#property indicator_color6 DimGray
#property indicator_color7 Silver

double PBuffer[];
double S1Buffer[];
double R1Buffer[];
double S2Buffer[];
double R2Buffer[];
double S3Buffer[];
double R3Buffer[];
double S0Buffer[];
double R0Buffer[];

int fontsize=10;
double P,R,S1,R1,S2,R2,S3,R3,tPrice;
double LastHigh,LastLow,x;

int deinit()
  {

   ObjectDelete("Pivot");
   ObjectDelete("Support");
   ObjectDelete("Resistance");
   ObjectDelete("38.2");
   ObjectDelete("50.0");
   ObjectDelete("50.0");
   ObjectDelete("61.8");   

   return(0);
  }

int init()
  {
   string short_name;

   SetIndexStyle(0,DRAW_LINE,0,2,Gold);
   SetIndexStyle(1,DRAW_LINE,0,2,Brown);
   SetIndexStyle(2,DRAW_LINE,0,2,Green);
   SetIndexStyle(3,DRAW_LINE,1,0,Silver);
   SetIndexStyle(4,DRAW_LINE,1,0,DimGray);
   SetIndexStyle(5,DRAW_LINE,1,0,DimGray);
   SetIndexStyle(6,DRAW_LINE,1,0,Silver);
   SetIndexBuffer(0,PBuffer);
   SetIndexBuffer(1,S1Buffer);
   SetIndexBuffer(2,R1Buffer);
   SetIndexBuffer(3,S2Buffer);
   SetIndexBuffer(4,R2Buffer);
   SetIndexBuffer(5,S3Buffer);
   SetIndexBuffer(6,R3Buffer);

   short_name="Fibonacci Pivot Points";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);

   SetIndexDrawBegin(0,1);

   return(0);
  }

int start()

  {
   int    counted_bars=IndicatorCounted();

   int limit, i;

if (counted_bars==0)
{
   x=Period();
   if (x>240) return(-1);
   ObjectCreate("Pivot", OBJ_TEXT, 0, 0,0);  ObjectSetText("Pivot", "Pivot",fontsize,"Arial",Gold);
   
   ObjectCreate("Support", OBJ_TEXT, 0, 0, 0); ObjectSetText("Support", "Support",fontsize,"Arial",Brown);
   ObjectCreate("Resistance", OBJ_TEXT, 0, 0, 0); ObjectSetText("Resistance", "Resistance",fontsize,"Arial",Green);
   
   ObjectCreate("38.2", OBJ_TEXT, 0, 0, 0); ObjectSetText("38.2", "38.2",fontsize,"Arial",Silver);   
   ObjectCreate("50.0", OBJ_TEXT, 0, 0, 0); ObjectSetText("50.0", "50.0",fontsize,"Arial",DimGray);
   ObjectCreate("50.0", OBJ_TEXT, 0, 0, 0); ObjectSetText("50.0", "50.0",fontsize,"Arial",DimGray);
   ObjectCreate("61.8", OBJ_TEXT, 0, 0, 0); ObjectSetText("61.8", "61.8",fontsize,"Arial",Silver);
}
   if(counted_bars<0) return(-1);

   limit=(Bars-counted_bars)-1;

for (i=limit; i>=0;i--)
{ 

if (High[i+1]>LastHigh) LastHigh=High[i+1];
if (Low[i+1]<LastLow) LastLow=Low[i+1];
if (TimeHour(Time[i])!=TimeHour(Time[i+1]))
   { 
   
   P =(LastHigh+LastLow+Close[i+1]+Close[i+1])/4;
   
   tPrice =(LastHigh+LastLow+Close[i+1]+Close[i+1])/2;
   R1 = tPrice - LastLow;
   S1 = tPrice - LastHigh;

   R = R1-S1;
   R2 = S1 + (R * 0.382);
   S2 = S1 + (R * 0.500);
   R3 = S1 + (R * 0.500);
   S3 = S1 + (R * 0.618);

   LastLow=Open[i]; LastHigh=Open[i];

   ObjectMove("Pivot", 0, Time[i],P);
   
   ObjectMove("Support", 0, Time[i],S1);
   ObjectMove("Resistance", 0, Time[i],R1);
   
   ObjectMove("38.2", 0, Time[i],R2);
   ObjectMove("50.0", 0, Time[i],S2);
   ObjectMove("50.0", 0, Time[i],R3);
   ObjectMove("61.8", 0, Time[i],S3);

   }
   
    PBuffer[i]=P;
    S1Buffer[i]=S1;
    R1Buffer[i]=R1;
    S2Buffer[i]=S2;
    R2Buffer[i]=R2;
    S3Buffer[i]=S3;
    R3Buffer[i]=R3;
}

   return(0);
  }