//+------------------------------------------------------------------+
//|                                              fibopiv daily.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete("DS1");
   ObjectDelete("DS2");
   ObjectDelete("DS3");
   ObjectDelete("DR1");
   ObjectDelete("DR2");
   ObjectDelete("DR3");
   ObjectDelete("DAILY PIVOT");
   ObjectDelete("Daily Support 1");
   ObjectDelete("Daily Support 2");
   ObjectDelete("Daily Support 3");
   ObjectDelete("Daily Pivot level");
   ObjectDelete("Daily Resistance 1");
   ObjectDelete("Daily Resistance 2");
   ObjectDelete("Daily Resistance 3");
   Comment(" ");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   
//----
double rates[1][6],daily_close,daily_high,daily_low;
ArrayCopyRates(rates, Symbol(), PERIOD_D1);

if(DayOfWeek() == 1)
{
   if(TimeDayOfWeek(iTime(Symbol(),PERIOD_D1,1)) == 5)
   {
       daily_close = rates[1][4];
       daily_high = rates[1][3];
       daily_low = rates[1][2];
   }
   else
   {
      for(int d = 5;d>=0;d--)
      {
         if(TimeDayOfWeek(iTime(Symbol(),PERIOD_D1,d)) == 5)
         {
             daily_close = rates[d][4];
             daily_high = rates[d][3];
             daily_low = rates[d][2];
         }
         
      }  
   }
}
else
{
    daily_close = rates[1][4];
    daily_high = rates[1][3];
    daily_low = rates[1][2];
}


//---- Calculate Pivots

Comment("\nDaily quotations:\nH ",daily_high,"\nL ",daily_low, "\nC ",daily_close);
double R = daily_high - daily_low;//range
double mp = (daily_high + daily_low + daily_close)/3;// Standard Pivot
double mr3 = mp + (R * 1.000);
double mr2 = mp + (R * 0.618);
double mr1 = mp + (R * 0.382);
double ms1 = mp - (R * 0.382);
double ms2 = mp - (R * 0.618);
double ms3 = mp - (R * 1.000);

drawLine(mr3,"DR3", DarkOrange,0);
drawLabel("Daily Resistance 3",mr3,DarkOrange);
drawLine(mr2,"DR2", DarkOrange,0);
drawLabel("Daily Resistance 2",mr2,DarkOrange);
drawLine(mr1,"DR1", DarkOrange,0);
drawLabel("Daily Resistance 1",mr1,DarkOrange);

drawLine(mp,"DAILY PIVOT",DarkOrchid,1);
drawLabel("Daily Pivot ",mp,DarkOrchid);

drawLine(ms1,"DS1",LawnGreen,0);
drawLabel("Daily Support 1",ms1,LawnGreen);
drawLine(ms2,"DS2",LawnGreen,0);
drawLabel("Daily Support 2",ms2,LawnGreen);
drawLine(ms3,"DS3",Green,0);
drawLabel("Daily Support 3",ms3,LawnGreen);


//----
   return(0);
  }
//+------------------------------------------------------------------+
void drawLabel(string name,double lvl,color Color)
{
    if(ObjectFind(name) != 0)
    {
        ObjectCreate(name, OBJ_TEXT, 0, Time[10], lvl);
        ObjectSetText(name, name, 8, "Lucida Handwriting", EMPTY);
        ObjectSet(name, OBJPROP_COLOR, Color);
    }
    else
    {
        ObjectMove(name, 0, Time[10], lvl);
    }
}


void drawLine(double lvl,string name, color Col,int type)
{
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            
            if(type == 1)
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,1);
            
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            
            if(type == 1)
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,1);
          
         }
}