//|------------------------------------------------------------------|
//|                                   Indicator Forex Millionaire.mq4|
//|                                    Copyright  2013 James Gold   |
//|                                             expoforex2@gmail.com |
//+------------------------------------------------------------------+
#property copyright "James Gold"
#property link "expoforex2@gmail.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 White
#property indicator_color2 Red

extern ENUM_TIMEFRAMES    TimeFrame        = PERIOD_CURRENT;
extern bool               cci_filter       = True;
extern int                cci_period       = 55;
extern ENUM_APPLIED_PRICE CCIPrice         = PRICE_CLOSE;
extern int                cci_level        = 53;
extern bool               smooth           = false;
extern string             note1            = "if smooth = true, then you use";
extern string             note2            = "the t3 period, t3 hot, and t3 original";
extern int                T3Period         = 3;
extern double             T3Hot            = 0.7;
extern bool               T3Original       = true;
extern bool               alertsOn         = false;
extern bool               alertsOnCurrent  = true;
extern bool               alertsMessage    = true;
extern bool               alertsSound      = false;
extern bool               alertsNotify     = false;
extern bool               alertsEmail      = false;
extern string             soundFile        = "alert2.wav";
extern bool               ArrowsOnFirstBar = true;
extern int                arrowWidth       = 2;

double buf_1[];
double buf_2[];
double trend[];
string indicatorFileName;
bool   returnBars;


int init() 
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,buf_1); SetIndexStyle(0,DRAW_ARROW,0,arrowWidth); SetIndexArrow(0,233);
   SetIndexBuffer(1,buf_2); SetIndexStyle(1,DRAW_ARROW,0,arrowWidth); SetIndexArrow(1,234);
   SetIndexBuffer(2,trend);
 
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame==-99;
   TimeFrame         = MathMax(TimeFrame,_Period);
return(0);
}

int start() 
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { buf_1[0] = limit+1; return(0); }
           if (TimeFrame!=Period())
           {
               int shift = -1; if (ArrowsOnFirstBar) shift=1;
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                   int y = iBarShift(NULL,TimeFrame,Time[i]);   
                   int x = iBarShift(NULL,TimeFrame,Time[i+shift]);            
                   
                   if (x!=y)
                   {
                      buf_1[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,cci_filter,cci_period,CCIPrice,cci_level,smooth,"","",T3Period,T3Hot,T3Original,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,0,y);
                      buf_2[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,cci_filter,cci_period,CCIPrice,cci_level,smooth,"","",T3Period,T3Hot,T3Original,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,1,y);
                   }
                   else
                   {
                      buf_1[i]  = EMPTY_VALUE;
                      buf_2[i]  = EMPTY_VALUE;
                   }
            }
            return(0);
            }

     for (i=limit; i>=0; i--)
     { 
         trend[i] = 0;
         if (Close[i+1] > Close[i+2] && Close[i+3] > Close[i+2] && Close[i+4] > Close[i+3] &&
             Low[i+1] > Low[i+2] && Low[i+3] > Low[i+2] && Low[i+4] > Low[i+3]) trend[i] = 1;
         if (Close[i+1] < Close[i+2] && Close[i+3] < Close[i+2] && Close[i+4] < Close[i+3] &&
             High[i+1] < High[i+2] && High[i+3] < High[i+2] && High[i+4] < High[i+3]) trend[i] =-1 ;
         buf_1[i] = EMPTY_VALUE;
         buf_2[i] = EMPTY_VALUE;
         if (cci_filter) 
         {
           if (!smooth) { double cci = iCCI(NULL,0,cci_period,CCIPrice,i); } 
           else         {        cci = iCustom(NULL,0,"t3 cci",cci_period,CCIPrice,T3Period,T3Hot,T3Original,0,i); }
         }

         if (trend[i]>0 && (!cci_filter || (cci_filter && cci < -cci_level)))
         {
            buf_1[i+1] = Low[i+1]-2*15*Point;
         }
         if (trend[i]<0 && (!cci_filter || (cci_filter && cci > cci_level)))
         {
            buf_2[i+1] = High[i+1]+2*15*Point;
         }
    }

    //
    //
    //
    //
    //
    
    if (alertsOn)
    {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,TimeFrame,whichBar)); 
      
      //
      //
      //
      //
      //
      
      if (buf_1[whichBar+1] == EMPTY_VALUE && buf_1[whichBar] != EMPTY_VALUE) doAlert(whichBar,"up");
      if (buf_2[whichBar+1] == EMPTY_VALUE && buf_2[whichBar] != EMPTY_VALUE) doAlert(whichBar,"down");
    } 
return(0);
  }
  
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Haos Visual ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " Haos Visual "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}






