//+------------------------------------------------------------------+
//|                                               GoldSuperCycle.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window

#property indicator_buffers 3
#property indicator_color1 DodgerBlue  //Red  //Aqua
#property indicator_color2 Red
#property indicator_color3 Yellow
#property indicator_width1 4
#property indicator_width2 4
#property indicator_width3 4

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtHBuffer1[];
double ExtHBuffer2[];
double ExtHBuffer3[];

extern string    Cmt0 = "Sentiment Variables";
extern int       SentimentPeriod = 12;

extern string    Cmt1 = "Emotion Variables";
extern int       EmotionSSP = 7;
extern double    EmotionKmax = 50.6; //24 21.6 21.6 
extern int       EmotionCountBars = 3000;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(6);
   SetIndexStyle(0,DRAW_HISTOGRAM,0,4);  //Red
   SetIndexBuffer(0,ExtHBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM,0,4);  //Aqua
   SetIndexBuffer(1,ExtHBuffer2);
   SetIndexStyle(2,DRAW_HISTOGRAM,0,4);  //Yellow
   SetIndexBuffer(2,ExtHBuffer3);

   SetIndexBuffer(3,ExtMapBuffer1);
   SetIndexBuffer(4,ExtMapBuffer2);
   SetIndexBuffer(5,ExtMapBuffer3);

   IndicatorShortName("GoldSuperCycle");
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars = IndicatorCounted();
   int i = 0;
   
   if (EmotionCountBars >= Bars) 
   {
     EmotionCountBars = Bars;
   }
   
   if (Bars <= (EmotionSSP + 1)) 
   {
     return(0);
   }

   if(counted_bars< EmotionSSP+1)
   {
     for(i=1;i<=EmotionSSP;i++)
     {
       ExtMapBuffer1[EmotionCountBars-i]=0.0;
       ExtMapBuffer2[EmotionCountBars-i]=0.0;
       ExtMapBuffer3[EmotionCountBars-i]=0.0;
     }
   }
 
   SetIndexDrawBegin(0,Bars - EmotionCountBars + EmotionSSP);
   SetIndexDrawBegin(1,Bars - EmotionCountBars + EmotionSSP);
   SetIndexDrawBegin(2,Bars - EmotionCountBars + EmotionSSP);

   for(i = EmotionCountBars - EmotionSSP;i >= 0;i--) 
   { 
     ExtMapBuffer1[i] = 1; 
     ExtMapBuffer2[i] = 0; 
     ExtMapBuffer3[i] = 0;
     
     double SentimentValue0 = iCustom(NULL,0,"Symphonie_Sentiment_Indikator",SentimentPeriod,0,i);
     double EmotionValue0 = iCustom(NULL,0,"Symphonie_Market_Emotion_Indikator",EmotionSSP,EmotionKmax,EmotionCountBars,0,i);
     double EmotionValue1 = iCustom(NULL,0,"Symphonie_Market_Emotion_Indikator",EmotionSSP,EmotionKmax,EmotionCountBars,1,i);
     
     if ((SentimentValue0 > 0.0) && (EmotionValue0 == 1.0))
     {
        ExtHBuffer1[i] = 1;
        ExtHBuffer2[i] = 0;
        ExtHBuffer3[i] = 0;
     }
     else
     {
       if ((SentimentValue0 < 0.0) && (EmotionValue1 == 1.0))
       {
         ExtHBuffer1[i] = 0;
         ExtHBuffer2[i] = 1;
         ExtHBuffer3[i] = 0;
       }
       else
       {
         ExtHBuffer1[i] = 0;
         ExtHBuffer2[i] = 0;
         ExtHBuffer3[i] = 1;

       }
         
      }
      


   }


//----
   
//----
   return(0);
}
//+------------------------------------------------------------------+