//------------------------------------------------------------------
#property copyright "www.forex-tsd.cm"
#property link      "www.forex-tsd.cm"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1  LimeGreen
#property indicator_color2  LimeGreen
#property indicator_color3  Orange
#property indicator_color4  Orange
#property indicator_color5  Orange
#property indicator_width2  3
#property indicator_width3  3
#property indicator_width4  3
#property indicator_style1  STYLE_DOT
#property indicator_style5  STYLE_DOT

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame      = PERIOD_CURRENT;
extern int             HighLowPeriod  = 10;

//
//
//
//
//

double bandUp[];
double bandMi[];
double bandMida[];
double bandMidb[];
double bandDn[];
double trend[];
string indicatorFileName;
bool   returnBars;


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,bandUp);
   SetIndexBuffer(1,bandMi);
   SetIndexBuffer(2,bandMida);
   SetIndexBuffer(3,bandMidb);
   SetIndexBuffer(4,bandDn);
   SetIndexBuffer(5,trend);
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == -99;
   TimeFrame         = MathMax(TimeFrame,_Period);
   return(0);
}
int deinit()
{
   return(0); 
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { bandUp[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (TimeFrame!=Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   if (trend[limit]==-1) CleanPoint(limit,bandMida,bandMidb);
   for(int i = limit; i >= 0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);               
      bandUp[i] = iHigh(NULL,TimeFrame,iHighest(NULL,TimeFrame,MODE_HIGH,HighLowPeriod,y));
      bandDn[i] = iLow (NULL,TimeFrame,iLowest (NULL,TimeFrame,MODE_LOW ,HighLowPeriod,y));
      bandMi[i] = (bandUp[i]+bandDn[i])/2.0;
      trend[i]  = trend[i+1];
         if (bandMi[i]>bandMi[i+1]) trend[i] =  1;
         if (bandMi[i]<bandMi[i+1]) trend[i] = -1;
         bandMida[i] = EMPTY_VALUE;
         bandMidb[i] = EMPTY_VALUE;
            if (trend[i] == -1) PlotPoint(i,bandMida,bandMidb,bandMi);
   }
   return(0);
}


//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}