//+------------------------------------------------------------------+
//|                                                HMA color nrp.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Yellow
#property indicator_color2 Green
#property indicator_color3 Green
#property indicator_color4 Orange
#property indicator_color5 Orange
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame = PERIOD_CURRENT;
extern int                HmaPeriod = 20;
extern ENUM_APPLIED_PRICE HmaPrice  = 0;
extern ENUM_MA_METHOD     HmaMethod = 3;


int    HalfPeriod;
int    HullPeriod;
double buffer0[];
double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer[];
double trend[];
string indicatorFileName;
bool   returnBars;


//+------------------------------------------------------------------
//|                                                                 |
//+------------------------------------------------------------------

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,buffer0);
   SetIndexBuffer(1,buffer1);
   SetIndexBuffer(2,buffer2);
   SetIndexBuffer(3,buffer3);
   SetIndexBuffer(4,buffer4);
   SetIndexBuffer(5,buffer);
   SetIndexBuffer(6,trend);
   
   HmaPeriod         = MathMax(2,HmaPeriod);
   HalfPeriod        = MathFloor(HmaPeriod/2);
   HullPeriod        = MathFloor(MathSqrt(HmaPeriod));
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame==-99;
   TimeFrame         = MathMax(TimeFrame,_Period);
   IndicatorShortName(timeFrameToString(TimeFrame)+" HMA");
   return(0);
}
int deinit() { return(0); }

//
//
//
//
//

int start()
{
   int counted_bars  = IndicatorCounted(); 
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
          int limit = MathMin(Bars - counted_bars,Bars-1);
          if (returnBars)  { buffer0[0] = limit+1; return(0); } 
  
   //
   //
   //
   //
   //
   
   if (TimeFrame == Period())
   {  
     if (trend[limit] ==  1) CleanPoint(limit,buffer1,buffer2);
     if (trend[limit] == -1) CleanPoint(limit,buffer3,buffer4);
     for(int i=limit; i>=0; i--) buffer[i]=iMA(NULL,0,HalfPeriod,0,HmaMethod,HmaPrice,i)*2-iMA(NULL,0,HmaPeriod,0,HmaMethod,HmaPrice,i);
     for(i=limit; i>=0; i--)
     {
        buffer0[i] = iMAOnArray(buffer,0,HullPeriod,0,HmaMethod,i);
        buffer1[i] = EMPTY_VALUE;
        buffer2[i] = EMPTY_VALUE;
        buffer3[i] = EMPTY_VALUE;
        buffer4[i] = EMPTY_VALUE;
      
        //
        //
        //
        //
        //

        trend[i] = trend[i+1];            
           if (buffer0[i]>buffer0[i+1]) trend[i] =  1; 
           if (buffer0[i]<buffer0[i+1]) trend[i] = -1; 
           if (trend[i] ==  1) PlotPoint(i,buffer1,buffer2,buffer0);
           if (trend[i] == -1) PlotPoint(i,buffer3,buffer4,buffer0);
      }
   return(0);
   }
   
   //
   //
   //
   //
   //
 
    limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
    if (trend[limit] ==  1) CleanPoint(limit,buffer1,buffer2);
    if (trend[limit] == -1) CleanPoint(limit,buffer3,buffer4);
    for(i=limit; i >= 0; i--)  
    {
       int y = iBarShift(NULL,TimeFrame,Time[i]);
          buffer0[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,HmaPeriod,HmaPrice,HmaMethod,0,y);
          trend[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,HmaPeriod,HmaPrice,HmaMethod,6,y);
          buffer1[i] = EMPTY_VALUE;
          buffer2[i] = EMPTY_VALUE;
          buffer3[i] = EMPTY_VALUE;
          buffer4[i] = EMPTY_VALUE;
    //
    //
    //
    //
    //
    
    }
    
    for (i=limit;i>=0;i--)
    {
       if (trend[i] ==  1) PlotPoint(i,buffer1,buffer2,buffer0);
       if (trend[i] == -1) PlotPoint(i,buffer3,buffer4,buffer0); 
    }
  
return(0); 
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
      if (first[i+2] == EMPTY_VALUE) {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
         }
      else {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
         }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}