//+------------------------------------------------------------------+
//|                                    Instantaneous Trendline Filter|
//|                         Copyright  2006, Luis Guilherme Damiani |
//|                                      http://www.damianifx.com.br |
//|
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Luis Guilherme Damiani"
#property link      "http://www.damianifx.com.br"
//----
#property indicator_buffers 2
#property indicator_chart_window
#property indicator_color1 Lime
#property indicator_color2 Red
//---- input parameters
extern string TimeFrame = "Current time frame";   
extern double       alpha=0.07;
extern int          maxbars=2000;
extern string Price_Choice="-----  Typical or Median  --------------";
extern bool is_median=true;
//---- buffers
double ind1[];
double ind2[];

string indicatorFileName;
bool   returnBars;
int    timeFrame;

//double AuxBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ind1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ind2);
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { ind1[0] = limit+1; return(0); }
   
            if (timeFrame!=Period())
            {
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,timeFrame,Time[i]);               
                     ind1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",alpha,maxbars,"",is_median,0,y);
                     ind2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",alpha,maxbars,"",is_median,1,y);   
               }
               return(0);
            }
   double pr0,pr1,pr2=0;
   
   if(limit>maxbars)limit=maxbars;
   //if (limit>Bars-1)limit=Bars-1;   
//---- 
   for(i=limit; i>=0;i--)
     {
      if(is_median)
        {
         pr0=(High[i]+Low[i])/2;
         pr1=(High[i+1]+Low[i+1])/2;
         pr2=(High[i+2]+Low[i+2])/2;
        }
      else
        {
         pr0=(High[i]+Low[i]+Close[i])/3;
         pr1=(High[i+1]+Low[i+1]+Close[i+1])/3;
         pr2=(High[i+2]+Low[i+2]+Close[i+2])/3;
        }
      ind1[i]=(alpha-MathPow(alpha/2,2))*pr0
      +(MathPow(alpha,2)/2)*pr1
      -(alpha-3*MathPow(alpha,2)/4)*pr2
      + 2*(1-alpha)*ind1[i+1]
      -MathPow(1-alpha,2)*ind1[i+2];
      ind2[i]=2*ind1[i]-ind1[i+2];
     }
//----
   return(0);
  }

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}