//+------------------------------------------------------------------+
//|                                               KeltnerChannel.mq4 |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1  Magenta
#property indicator_color2  Blue
#property indicator_color3  Magenta
#property indicator_color4  SkyBlue
#property indicator_color5  Magenta
#property indicator_style1  2
#property indicator_style2  2
#property indicator_style3  2

//
//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame       = PERIOD_CURRENT;
extern int                KCperiod        = 7;
extern ENUM_MA_METHOD     MA_MODE         = MODE_SMA;
extern ENUM_APPLIED_PRICE PRICE_MODE      = PRICE_CLOSE;
extern double             NumATRs         = 0.75;
extern bool               ATR_MODE        = false;
extern bool               alertsOn        = true;
extern bool               alertsOnCurrent = false;
extern bool               alertsMessage   = true;
extern bool               alertsSound     = false;
extern bool               alertsEmail     = false;
extern bool               alertsNotify    = false;
extern bool               showValues      = true;
extern double             Valueloc        = 1.5;
extern string             valueIdentifier = "KC8val";
extern color              txtUpColor      = SkyBlue; //Green;
extern color              txtDownColor    = Magenta; //Magenta; //Crimson; //Red;
extern bool               Interpolate     = true;

extern bool               ShowArrows      = true;
extern int                arrowSize       = 2;
extern int                uparrowCode     = 233;
extern int                dnarrowCode     = 234;
extern bool               ArrowsOnFirstBar= false;

//
//
//
//
//

double upper[];
double middle[];
double lower[];
double arrowUp[];
double arrowDn[];
double trend[];

string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                   
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,upper);
   SetIndexBuffer(1,middle);
   SetIndexBuffer(2,lower);
   SetIndexBuffer(3,arrowUp); 
   SetIndexBuffer(4,arrowDn); 
   SetIndexBuffer(5,trend); 
   if (ShowArrows)
   {
     SetIndexStyle(3,DRAW_ARROW,0,arrowSize); SetIndexArrow(3,uparrowCode);
     SetIndexStyle(4,DRAW_ARROW,0,arrowSize); SetIndexArrow(4,dnarrowCode);   
   }
   else
   {
     SetIndexStyle(3,DRAW_NONE);
     SetIndexStyle(4,DRAW_NONE);
   }       
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame==-99;
   TimeFrame         = MathMax(TimeFrame,_Period);
return(0);
}
int deinit() 
{   
   deleteValues();
return(0); 
}

//+------------------------------------------------------------------+
//|                                                                   
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMin(Bars-counted_bars,Bars-1);
         if (returnBars)  { upper[0] = limit; return(0); }

   //
   //
   //
   //
   //
   
   if (TimeFrame==Period())
   {
      for(i=limit; i>=0; i--)
      {
         middle[i] = iMA(NULL,0,KCperiod,0,MA_MODE,PRICE_MODE,i);

         if (ATR_MODE) double avg  = iATR(NULL,0,KCperiod,i);
         else { double sum=0; for (int x=0; x<KCperiod; x++) sum += High[i+x]-Low[i+x]; avg  = sum/KCperiod;}
         upper[i] = middle[i] + NumATRs*avg;
         lower[i] = middle[i] - NumATRs*avg;
         trend[i] = trend[i+1];                     
            if (Close[i] > upper[i]) trend[i] =  1;
            if (Close[i] < lower[i]) trend[i] = -1;
            
            //
            //
            //
            //
            //
      
            arrowUp[i] = EMPTY_VALUE;
            arrowDn[i] = EMPTY_VALUE;
            if (trend[i]!= trend[i+1])
            if (trend[i] == 1)
                  arrowUp[i] = Low[i]  - iATR(NULL,0,20,i)/1;
            else  arrowDn[i] = High[i] + iATR(NULL,0,20,i)/1;
            
            //
            //
            //
            //
            //
            
            if (showValues)
            {
              double dist = iATR(NULL,0,20,i)/Valueloc;
              string name = valueIdentifier+":"+Time[i];
              deleteValue(Time[i]);         
                
              if (trend[i] != trend[i+1])
              {
                if (trend[i] == 1)
                {
                  ObjectCreate(name, OBJ_TEXT, 0, Time[i],arrowUp[i]-dist);
                  ObjectSetText(name,DoubleToStr(Close[i],Digits) + " " 
                  + TimeToStr(Time[i],TIME_MINUTES),8,"Arial",txtUpColor);
                }
                else
                if (trend[i] == -1)
                {
                  ObjectCreate(name, OBJ_TEXT, 0, Time[i],arrowDn[i]+dist);
                  ObjectSetText(name,DoubleToStr(Close[i], Digits) + " " 
                  + TimeToStr(Time[i],TIME_MINUTES),8,"Arial",txtDownColor);
                }
             }
           }
      }
      
      //
      //
      //
      //
      //
   
      if (alertsOn)
      {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1;
        if (trend[whichBar] != trend[whichBar+1])
        {
           if (trend[whichBar] == 1) doAlert(whichBar,"upper");
           if (trend[whichBar] ==-1) doAlert(whichBar,"lower");
        }         
     }
      return(0);
   }      
   
   //
   //
   //
   //
   //
   
   int shift = -1; if (ArrowsOnFirstBar) shift=1;
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
       int y = iBarShift(NULL,TimeFrame,Time[i]);
       int z = iBarShift(NULL,TimeFrame,Time[i+shift]);
         upper[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,KCperiod,MA_MODE,PRICE_MODE,NumATRs,ATR_MODE,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,showValues,Valueloc,valueIdentifier,txtUpColor,txtDownColor,0,y);
         middle[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,KCperiod,MA_MODE,PRICE_MODE,NumATRs,ATR_MODE,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,showValues,Valueloc,valueIdentifier,txtUpColor,txtDownColor,1,y);
         lower[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,KCperiod,MA_MODE,PRICE_MODE,NumATRs,ATR_MODE,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,showValues,Valueloc,valueIdentifier,txtUpColor,txtDownColor,2,y); 
       if(z!=y)
       {
         arrowUp[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,KCperiod,MA_MODE,PRICE_MODE,NumATRs,ATR_MODE,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,showValues,Valueloc,valueIdentifier,txtUpColor,txtDownColor,3,y); 
         arrowDn[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,KCperiod,MA_MODE,PRICE_MODE,NumATRs,ATR_MODE,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,showValues,Valueloc,valueIdentifier,txtUpColor,txtDownColor,4,y); 
       }
       else
       {
         arrowUp[i] = EMPTY_VALUE;
         arrowDn[i] = EMPTY_VALUE;
       }
         
          //
          //
          //
          //
          //
            
          if (!Interpolate || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;

          //
          //
          //
          //
          //

          datetime time = iTime(NULL,TimeFrame,y);
             for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;
             for(int s = 1; s < n; s++) 
             {
  	             upper[i+s]  = upper[i]  + (upper[i+n]  - upper[i])  * s/n;
  	             middle[i+s] = middle[i] + (middle[i+n] - middle[i]) * s/n;
  	             lower[i+s]  = lower[i]  + (lower[i+n]  - lower[i])  * s/n;
             }
   }
return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message = StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)+" Keltner Channel price penetrated ",doWhat," band");
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Keltner Channel "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//
//
//
//
//

void deleteValues()
{
   string lookFor       = valueIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteValue(datetime time)
{
   string lookFor = valueIdentifier+":"+time; ObjectDelete(lookFor);
}

