//+------------------------------------------------------------------+
//|                                   Copyright  2010, Ivan Kornilov|
//|                                                        MaByMa.mq4|
//|                                   excelf@gmail.com, skype: excelf|
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Ivan Kornilov. All rights reserved."
#property link "excelf@gmail.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 Green
#property indicator_color4 Red
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 1
#property indicator_width4 1

extern int ma      = 25;
extern int signal  = 5;
extern int maType  = 3;
extern int maPrice = 0;
extern double arrowGap = 0.75;

extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";

double SignalBuffer1[];
double SignalBuffer2[];
double arrowUp[];
double arrowDn[];
double trend[];

int init(){
   IndicatorDigits(Digits + 1);
   IndicatorBuffers(5);
   SetIndexBuffer(0, SignalBuffer1);
   SetIndexBuffer(1, SignalBuffer2);
   SetIndexBuffer(2, arrowUp); SetIndexStyle(2, DRAW_ARROW); SetIndexArrow(2,241);
   SetIndexBuffer(3, arrowDn); SetIndexStyle(3, DRAW_ARROW); SetIndexArrow(3,242);
   SetIndexBuffer(4, trend);

   IndicatorShortName("MaByMa(" + ma + "," + signal + ")");
   SetIndexLabel(0, "SignalBuffer1");
   SetIndexLabel(1, "SignalBuffer2");
}



int start(){
   int counted_bars=IndicatorCounted();
   if(counted_bars > 0) {
       counted_bars--;
   }
   int limit = Bars - counted_bars - 1;

   for(int i = limit; i >= 0; i--) {
      SignalBuffer1[i] = iMA(NULL, 0, ma, 0, maType, maPrice, i);
      //SignalBuffer2[i] = indicators.getMaByMaValue(ma, signal, Period(), i);
   } 
   
   for(i = limit; i >= 0; i--) {
      SignalBuffer2[i] = iMAOnArray(SignalBuffer1, 0, signal, 0, maType, i);
      arrowUp[i] = EMPTY_VALUE;
      arrowDn[i] = EMPTY_VALUE;
      trend[i] = trend[i+1];
         if (SignalBuffer1[i] > SignalBuffer2[i]) trend[i] =  1;
         if (SignalBuffer1[i] < SignalBuffer2[i]) trend[i] = -1;
         if (trend[i]!=trend[i+1])
            if (trend[i] == 1) 
                  arrowUp[i] = MathMin(SignalBuffer1[i],SignalBuffer2[i]) -iATR(NULL,0,20,i)*arrowGap;
            else  arrowDn[i] = MathMax(SignalBuffer1[i],SignalBuffer2[i])+iATR(NULL,0,20,i*arrowGap);
            }
            
            if (alertsOn)
            {
            if (alertsOnCurrent)
                 int whichBar = 0;
            else     whichBar = 1;

            //
            //
            //
            //
            //
          
            if (trend[whichBar] != trend[whichBar+1])
            if (trend[whichBar] == 1)
                  doAlert("uptrend");
            else  doAlert("downtrend");       
   }
return(0);
}  

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," MaByMa ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," MaByMa "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
} 

