//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  Green
#property indicator_color4  Red
#property indicator_color5  Silver
#property indicator_color6  Gold
#property indicator_color7  Gray
#property indicator_color8  White
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width7  2
#property indicator_style6  STYLE_DOT
#property indicator_style8  STYLE_DOT

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame    = PERIOD_CURRENT;
extern ENUM_APPLIED_PRICE Macd1Price   =  PRICE_CLOSE;
extern int                Macd1Fast    =  12;
extern int                Macd1Slow    =  26;
extern int                Macd1Signal  =  9;
extern ENUM_APPLIED_PRICE Macd2Price   =  PRICE_CLOSE;
extern int                Macd2Fast    =  24;
extern int                Macd2Slow    =  52;
extern int                Macd2Signal  =  18;

double macd1up[];
double macd1dn[];
double macd1ln[];
double macd1si[];
double macd2up[];
double macd2dn[];
double macd2ln[];
double macd2si[];
string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,macd1up); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,macd1dn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,macd2up); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,macd2dn); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,macd1ln);
   SetIndexBuffer(5,macd1si);
   SetIndexBuffer(6,macd2ln);
   SetIndexBuffer(7,macd2si);
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame == -99;
      TimeFrame         = MathMax(TimeFrame,_Period);
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { macd1up[0] = limit+1; return(0); }
         if (TimeFrame != Period())
         {
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
            for(i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,TimeFrame,Time[i]);               
                  macd1up[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Macd1Price,Macd1Fast,Macd1Slow,Macd1Signal,Macd2Price,Macd2Fast,Macd2Slow,Macd2Signal,0,y);
                  macd1dn[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Macd1Price,Macd1Fast,Macd1Slow,Macd1Signal,Macd2Price,Macd2Fast,Macd2Slow,Macd2Signal,1,y);
                  macd2up[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Macd1Price,Macd1Fast,Macd1Slow,Macd1Signal,Macd2Price,Macd2Fast,Macd2Slow,Macd2Signal,2,y);
                  macd2dn[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Macd1Price,Macd1Fast,Macd1Slow,Macd1Signal,Macd2Price,Macd2Fast,Macd2Slow,Macd2Signal,3,y);
                  macd1ln[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Macd1Price,Macd1Fast,Macd1Slow,Macd1Signal,Macd2Price,Macd2Fast,Macd2Slow,Macd2Signal,4,y);
                  macd1si[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Macd1Price,Macd1Fast,Macd1Slow,Macd1Signal,Macd2Price,Macd2Fast,Macd2Slow,Macd2Signal,5,y);
                  macd2ln[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Macd1Price,Macd1Fast,Macd1Slow,Macd1Signal,Macd2Price,Macd2Fast,Macd2Slow,Macd2Signal,6,y);
                  macd2si[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Macd1Price,Macd1Fast,Macd1Slow,Macd1Signal,Macd2Price,Macd2Fast,Macd2Slow,Macd2Signal,7,y);
            }
            return(0);
         }

   //
   //
   //
   //
   //
   //

   for(i=limit; i >= 0; i--)
   {
      macd1ln[i] = iMA(NULL,0,Macd1Fast,0,MODE_EMA,Macd1Price,i)-iMA(NULL,0,Macd1Slow,0,MODE_EMA,Macd1Price,i);
      macd2ln[i] = iMA(NULL,0,Macd2Fast,0,MODE_EMA,Macd2Price,i)-iMA(NULL,0,Macd2Slow,0,MODE_EMA,Macd2Price,i);
      macd1up[i] = EMPTY_VALUE;
      macd1dn[i] = EMPTY_VALUE;
      macd2up[i] = EMPTY_VALUE;
      macd2dn[i] = EMPTY_VALUE;
      if (macd1ln[i]>0) macd1up[i] = macd1ln[i];
      if (macd1ln[i]<0) macd1dn[i] = macd1ln[i];
      if (macd2ln[i]>0) macd2up[i] = macd2ln[i];
      if (macd2ln[i]<0) macd2dn[i] = macd2ln[i];
   }   
   for(i=limit; i >= 0; i--)
   {
      macd1si[i] = iMAOnArray(macd1ln,0,Macd1Signal,0,MODE_EMA,i);
      macd2si[i] = iMAOnArray(macd2ln,0,Macd2Signal,0,MODE_EMA,i);
   }
   return(0);
}