//+------------------------------------------------------------------+
//|                                            #MTF_4_solar.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+

#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"





#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 5
#property indicator_buffers 8
#property indicator_color1 SeaGreen
#property indicator_color2 SeaGreen
#property indicator_color3 SeaGreen
#property indicator_color4 SeaGreen
#property indicator_color5 FireBrick
#property indicator_color6 FireBrick
#property indicator_color7 FireBrick
#property indicator_color8 FireBrick
//---- input parameters

//---- buffers
double UpBuffer_M5[];
double UpBuffer_M15[];
double UpBuffer_M30[];
double UpBuffer_H1[];
double DownBuffer_M5[];
double DownBuffer_M15[];
double DownBuffer_M30[];
double DownBuffer_H1[];


datetime dt5[200], dt15[200], dt30[200], dth1[200];   

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,159);
   SetIndexBuffer(0,UpBuffer_M5);
   SetIndexEmptyValue(0,-40.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,159);
   SetIndexBuffer(1,UpBuffer_M15);
   SetIndexEmptyValue(1,-40.0);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,159);
   SetIndexBuffer(2,UpBuffer_M30);
   SetIndexEmptyValue(2,-40.0);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,159);
   SetIndexBuffer(3,UpBuffer_H1);
   SetIndexEmptyValue(3,-40.0);
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(4,159);
   SetIndexBuffer(4,DownBuffer_M5);
   SetIndexEmptyValue(4,-40.0);
   SetIndexStyle(5,DRAW_ARROW);
   SetIndexArrow(5,159);
   SetIndexBuffer(5,DownBuffer_M15);
   SetIndexEmptyValue(5,-40.0);
   SetIndexStyle(6,DRAW_ARROW);
   SetIndexArrow(6,159);
   SetIndexBuffer(6,DownBuffer_M30);
   SetIndexEmptyValue(6,-40.0);
   SetIndexStyle(7,DRAW_ARROW);
   SetIndexArrow(7,159);
   SetIndexBuffer(7,DownBuffer_H1);
   SetIndexEmptyValue(7,-40.0);
   
   IndicatorShortName("MTF_4_solar M5,M15,M30,M60");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   int limit, shift;
   if(counted_bars<0) return(-1);
   if (counted_bars==0) limit=Bars-1;  // limit = Bars-MinBars-1;
//---- last counted bar will be recounted
   if(counted_bars>0) limit=Bars-counted_bars;
   limit--;

   int i5 = 0, i15 = 0, i30 = 0, ih1 = 0;

   static bool fft = true;
   
   //if (NewBar()) // Update array every 15 minutes
   {
      ArrayCopySeries(dt5,MODE_TIME,Symbol(),PERIOD_M5); 
      ArrayCopySeries(dt15,MODE_TIME,Symbol(),PERIOD_M15); 
      ArrayCopySeries(dt30,MODE_TIME,Symbol(),PERIOD_M30); 
      ArrayCopySeries(dth1,MODE_TIME,Symbol(),PERIOD_H1); 
   }   
   
   if ((fft) && (Symbol() == "EURUSD"))
   {
      fft = false;
      datetime d = iTime(NULL, PERIOD_D1, 0);
      for (int j=0; j<80; j++)
      {
         Print(j,") ",dt5[j]-d," ",dt15[j]-d, " ", dt30[j]-d," ", dth1[j]-d);
      }
   }
   for(int i=0; i<limit; i++)
   {   
      datetime ddt = iTime(NULL, 0, i);
      if (ddt<dt5[i5]) i5++;
      if (ddt<dt15[i15]) i15++;
      if (ddt<dt30[i30]) i30++;
      if (ddt<dth1[ih1])  ih1++;
      
      
       double COG5=iCustom(NULL,PERIOD_M5,"SOLAR WIND",0,i5);
       double COG5S=0;
      
      
      double  COG15=iCustom(NULL,PERIOD_M15,"SOLAR WIND",0,i15);
      double  COG15S=0;
      
      
     double   COG30=iCustom(NULL,PERIOD_M30,"SOLAR WIND",0,i30);
     double  COG30S=0;
      
      
      double COGH1=iCustom(NULL,PERIOD_H1,"SOLAR WIND",0,ih1);
      double COGH1S=0;
      
      
      UpBuffer_M5[i] = -40;    DownBuffer_M5[i] = -40; 
      UpBuffer_M15[i] = -40;    DownBuffer_M15[i] = -40; 
      UpBuffer_M30[i]  = -40;    DownBuffer_M30[i]  = -40; 
      UpBuffer_H1[i]  = -40;    DownBuffer_H1[i]  = -40; 

      if (COG5 >COG5S) UpBuffer_M5[i] = 1; if (COG5 <COG5S) DownBuffer_M5[i] = 1;
      if (COG15 >COG15S) UpBuffer_M15[i] = 2; if (COG15 <COG15S) DownBuffer_M15[i] = 2;
      if (COG30 >COG30S) UpBuffer_M30[i]   = 3; if (COG30 <COG30S) DownBuffer_M30[i]  = 3;
      if (COGH1 >COGH1S) UpBuffer_H1[i]   = 4; if (COGH1 <COGH1S) DownBuffer_H1[i]  = 4;
   }

   return(0);
  }
//+------------------------------------------------------------------+

/*
bool NewBar()
{
   static datetime dt = 0;
   if (dt != iTime(NULL, PERIOD_M15, 0))
   {
      dt = iTime(NULL, PERIOD_M15, 0);
   }
   return(false);
}
*/