//+------------------------------------------------------------------+
//|                                                       MTF AC.mq4 |
//|                                          Copyright  2009,matfx  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009,matfx "
#property link      "http://www.forex-tsd.com"

#property indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  Black
#property  indicator_width2  4
#property  indicator_color2  Green
#property  indicator_width2  4
#property  indicator_color3  Brown
#property  indicator_width3  4

extern int TimeFrame=0;

//---- indicator buffers
double     ExtMapBuffer0[];
double     ExtMapBuffer1[];
double     ExtMapBuffer2[];
double     ExtMapBuffer3[];
double     ExtMapBuffer4[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  //---- 2 additional buffers are used for counting.
   IndicatorBuffers(3);
//---- drawing settings
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   IndicatorDigits(Digits+2);
   SetIndexDrawBegin(0,38);
   SetIndexDrawBegin(1,38);
   SetIndexDrawBegin(2,38);
//---- 4 indicator buffers mapping
   SetIndexBuffer(0,ExtMapBuffer0);
   SetIndexBuffer(1,ExtMapBuffer1);
   SetIndexBuffer(2,ExtMapBuffer2);
   SetIndexBuffer(3,ExtMapBuffer3);
   SetIndexBuffer(4,ExtMapBuffer4);
//---- name for DataWindow and indicator subwindow label
   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   }
   IndicatorShortName("MTF_AC("+TimeFrameStr+")");   
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);
   }
 
   
//---- 
   
  
//+------------------------------------------------------------------+
//|   MTF Accelerator/Decelerator Oscillator                         |
//+------------------------------------------------------------------+
int start()
  {
   
    datetime TimeArray[];
   int    i,limit,y=0,counted_bars=IndicatorCounted();
 
// Plot defined time frame on to current time frame
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit=Bars-counted_bars+TimeFrame/Period();

   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++;

/***********************************************************   
   Add your main indicator loop below.  You can reference an existing
      indicator with its iName  or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator time frame
   Rule 3:  Use 'y' for your indicator's shift value
 **********************************************************/  
 
   ExtMapBuffer0[i]=iCustom(NULL,TimeFrame,"Accelerator",0,y) ; 
   ExtMapBuffer1[i]=iCustom(NULL,TimeFrame,"Accelerator",1,y) ; 
   ExtMapBuffer2[i]=iCustom(NULL,TimeFrame,"Accelerator",2,y) ; 
   ExtMapBuffer3[i]=iCustom(NULL,TimeFrame,"Accelerator",3,y) ;  
   
   
   }                 


 
 
    return(0);
  }
//+------------------------------------------------------------------+