//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
#property strict
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  Green
#property indicator_color4  Red
#property indicator_color5  Silver
#property indicator_color6  Gold
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width6  2
enum enTimeFrames
{
   tf_cu  = 0,              // Current time frame
   tf_m1  = PERIOD_M1,      // 1 minute
   tf_m5  = PERIOD_M5,      // 5 minutes
   tf_m15 = PERIOD_M15,     // 15 minutes
   tf_m30 = PERIOD_M30,     // 30 minutes
   tf_h1  = PERIOD_H1,      // 1 hour
   tf_h4  = PERIOD_H4,      // 4 hours
   tf_d1  = PERIOD_D1,      // Daily
   tf_w1  = PERIOD_W1,      // Weekly
   tf_mb1 = PERIOD_MN1      // Monthly
};

//
//
//
//
//
extern enTimeFrames TimeFrame              = tf_cu;  // Time frame to use
extern string             PARAMETERS1      = "==== FIRST OSMA PARAMETERS ====";
extern int                FastMaPeriod1    = 12;            // 1st osma - fast ma PERIOD
extern ENUM_MA_METHOD     FastMaMode1      = MODE_EMA;      // 1st osma - fast ma MODE
extern ENUM_APPLIED_PRICE FastMaPrice1     = PRICE_CLOSE;   // 1st osma - fast ma PRICE
extern string             Divisor1         = "";            // ----------------------------------------------
extern int                SlowMaPeriod1    = 26;            // 1st osma - slow ma PERIOD
extern ENUM_MA_METHOD     SlowMaMode1      = MODE_EMA;      // 1st osma - slow ma MODE
extern ENUM_APPLIED_PRICE SlowMaPrice1     = PRICE_CLOSE;   // 1st osma - slow ma PRICE
extern string             Divisor2         = "";            // ----------------------------------------------
extern int                SignalMaPeriod1  = 9;             // 1st osma - signal ma PERIOD
extern ENUM_MA_METHOD     SignalMaMode1    = MODE_EMA;      // 1st osma - signal ma MODE
extern string             PARAMETERS2      = "==== SECOND OSMA PARAMETERS ====";
extern int                FastMaPeriod2    = 24;            // 2nd osma - fast ma PERIOD
extern ENUM_MA_METHOD     FastMaMode2      = MODE_EMA;      // 2nd osma - fast ma MODE
extern ENUM_APPLIED_PRICE FastMaPrice2     = PRICE_CLOSE;   // 2nd osma - fast ma PRICE
extern string             Divisor3         = "";            // ----------------------------------------------
extern int                SlowMaPeriod2    = 52;            // 2nd osma - slow ma PERIOD
extern ENUM_MA_METHOD     SlowMaMode2      = MODE_EMA;      // 2nd osma - slow ma MODE
extern ENUM_APPLIED_PRICE SlowMaPrice2     = PRICE_CLOSE;   // 2nd osma - slow ma PRICE
extern string             Divisor4         = "";            // ----------------------------------------------
extern int                SignalMaPeriod2  = 18;            // 2nd osma - signal ma PERIOD
extern ENUM_MA_METHOD     SignalMaMode2    = MODE_EMA;      // 2nd osma - signal ma MODE
extern bool               Interpolate      = true;

//
//
//
//
//


double osma1up[];
double osma1dn[];
double osma2up[];
double osma2dn[];
double osma1[];
double osma2[];
double macd1[];
double sig1[];
double macd2[];
double sig2[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{

   IndicatorBuffers(10);  
   SetIndexBuffer(0,osma1up); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,osma1dn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,osma2up); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,osma2dn); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,osma1);
   SetIndexBuffer(5,osma2);
   SetIndexBuffer(6,macd1);
   SetIndexBuffer(7,macd2);
   SetIndexBuffer(8,sig1);
   SetIndexBuffer(9,sig2);      
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99; 
         TimeFrame         = MathMax(TimeFrame,_Period);
   IndicatorShortName(timeFrameToString(TimeFrame)+" Osma x 2");
return(0);
}

int deinit()  {   return(0);  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { osma1up[0] = limit; return(0); }
         if (TimeFrame != Period())
         {
            limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
            for (i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,TimeFrame,Time[i]);
               osma1[i]   = iCustom(NULL,TimeFrame,indicatorFileName,tf_cu,"",FastMaPeriod1,FastMaMode1,FastMaPrice1,Divisor1,SlowMaPeriod1,SlowMaMode1,SlowMaPrice1,Divisor2,SignalMaPeriod1,SignalMaMode1,"",FastMaPeriod2,FastMaMode2,FastMaPrice2,Divisor3,SlowMaPeriod2,SlowMaMode2,SlowMaPrice2,Divisor4,SignalMaPeriod2,SignalMaMode2,4,y);
               osma2[i]   = iCustom(NULL,TimeFrame,indicatorFileName,tf_cu,"",FastMaPeriod1,FastMaMode1,FastMaPrice1,Divisor1,SlowMaPeriod1,SlowMaMode1,SlowMaPrice1,Divisor2,SignalMaPeriod1,SignalMaMode1,"",FastMaPeriod2,FastMaMode2,FastMaPrice2,Divisor3,SlowMaPeriod2,SlowMaMode2,SlowMaPrice2,Divisor4,SignalMaPeriod2,SignalMaMode2,5,y);
               osma1up[i] = EMPTY_VALUE;
               osma1dn[i] = EMPTY_VALUE;
               osma2up[i] = EMPTY_VALUE;
               osma2dn[i] = EMPTY_VALUE;
                  if (osma1[i]>0) osma1up[i] = osma1[i];
                  if (osma1[i]<0) osma1dn[i] = osma1[i];
                  if (osma2[i]>0) osma2up[i] = osma2[i];
                  if (osma2[i]<0) osma2dn[i] = osma2[i];
               
               //
               //
               //
               //
               //
               
               if (!Interpolate || (i>0 && y==iBarShift(NULL,0,TimeFrame,Time[i-1]))) continue;
               int n,k; datetime time = iTime(NULL,TimeFrame,y);
                  for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
                  for(k = 1; k<n && (i+k)<Bars && (i+n)<Bars; k++)
                  {
                     osma1[i+k] = osma1[i] + (osma1[i+n]-osma1[i])*k/n; if (osma1up[i]!=EMPTY_VALUE) osma1up[i+k]=osma1[i+k]; if (osma1dn[i]!=EMPTY_VALUE) osma1dn[i+k]=osma1[i+k];
                     osma2[i+k] = osma2[i] + (osma2[i+n]-osma2[i])*k/n; if (osma2up[i]!=EMPTY_VALUE) osma2up[i+k]=osma2[i+k]; if (osma2dn[i]!=EMPTY_VALUE) osma2dn[i+k]=osma2[i+k];
                  }                     
            }
            return(0);
         }


   //
   //
   //
   //
   //
   
     for(i=limit; i>=0; i--) macd1[i] = iMA(NULL,0,FastMaPeriod1,0,FastMaMode1,FastMaPrice1,i)-iMA(NULL,0,SlowMaPeriod1,0,SlowMaMode1,SlowMaPrice1,i);
     for(i=limit; i>=0; i--) macd2[i] = iMA(NULL,0,FastMaPeriod2,0,FastMaMode2,FastMaPrice2,i)-iMA(NULL,0,SlowMaPeriod2,0,SlowMaMode2,SlowMaPrice2,i);
     for(i=limit; i>=0; i--) sig1[i]  = iMAOnArray(macd1,0,SignalMaPeriod1,0,SignalMaMode1,i);
     for(i=limit; i>=0; i--) sig2[i]  = iMAOnArray(macd2,0,SignalMaPeriod2,0,SignalMaMode2,i);
     for(i=limit; i>=0; i--)
     {    
         osma1[i]   = macd1[i]-sig1[i];
         osma2[i]   = macd2[i]-sig2[i];
         osma1up[i] = EMPTY_VALUE;
         osma1dn[i] = EMPTY_VALUE;
         osma2up[i] = EMPTY_VALUE;
         osma2dn[i] = EMPTY_VALUE;
         if (osma1[i]>0) osma1up[i] = osma1[i];
         if (osma1[i]<0) osma1dn[i] = osma1[i];
         if (osma2[i]>0) osma2up[i] = osma2[i];
         if (osma2[i]<0) osma2dn[i] = osma2[i];
         
      }
      return(0);
      }
      
//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
      