/*

*********************************************************************
          
                 RSI with Trend Catcher signal
                      
                              
                          by Matsu
              based on codes from various sources
                  
*********************************************************************

*/


#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 Red
#property indicator_color4 Lime
#property indicator_color5 Red
#property indicator_color6 Gold
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2
#property indicator_width6 2
#property indicator_level1 60
#property indicator_level2 50
#property indicator_level3 40

extern string TimeFrame       = "Current time frame";
extern int    BBPrd           = 20;
extern double BBDev           = 2.0;
extern int    SBPrd           = 13;
extern int    SBATRPrd        = 21;
extern double SBFactor        = 2;
extern int    SBShift         = 1;
extern int    RSIPeriod       = 21;
extern int    BullLevel       = 50;
extern int    BearLevel       = 50;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsNotify    = true;
extern bool   alertsEmail     = true;

double Rsi[];
double rsida[];
double rsidb[];
double Buy[];
double Sell[];
double Squeeze[];
double slope[];

int    timeFrame;

//
//
//
//
//

int init() 
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,Rsi);
   SetIndexBuffer(1,rsida);
   SetIndexBuffer(2,rsidb);
   SetIndexBuffer(3,Buy);    SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,159);  
   SetIndexBuffer(4,Sell);   SetIndexStyle(4,DRAW_ARROW); SetIndexArrow(4,159);
   SetIndexBuffer(5,Squeeze);SetIndexStyle(5,DRAW_ARROW); SetIndexArrow(5,159); 
   SetIndexBuffer(6,slope);
      
   timeFrame = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" RSI("+RSIPeriod+")");
   return(0);
   
}



int start() 
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit=MathMax(Bars-counted_bars,3*timeFrame/Period());
            
   //
   //
   //
   //
   //
   
   if (slope[limit] == -1) CleanPoint(limit,rsida,rsidb);
   for(int i=limit; i>=0; i--) 
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      Rsi[i]   = iRSI(NULL,timeFrame,RSIPeriod,PRICE_CLOSE,y);
      rsida[i] = EMPTY_VALUE;
      rsida[i] = EMPTY_VALUE;
      slope[i] = slope[i+1];
      
      // ========= Two-tone RSI
      
      if (Rsi[i]>BullLevel) slope[i] = 1;
      if (Rsi[i]<BearLevel) slope[i] =-1; 
      if (slope[i] == -1) PlotPoint(i,rsida,rsidb,Rsi);
         
      // ========= Two-tone RSI Ends
      
      // ========= Squeeze Signals
      
      double BBMA         = iMA(NULL,timeFrame,BBPrd,0,MODE_SMA,PRICE_CLOSE,y);
      double SBMA         = iMA(NULL,timeFrame,SBPrd,0,MODE_EMA,PRICE_CLOSE,y+SBShift);
      double TopBBand     = iBands(NULL,timeFrame,BBPrd,BBDev,0,PRICE_CLOSE,MODE_UPPER,y);
	   double BotBBand     = iBands(NULL,timeFrame,BBPrd,BBDev,0,PRICE_CLOSE,MODE_LOWER,y);
      double TopSBand     = SBMA + (SBFactor * iATR(NULL,timeFrame,SBATRPrd,y+SBShift));
      double BotSBand     = SBMA - (SBFactor * iATR(NULL,timeFrame,SBATRPrd,y+SBShift));
      double TopBBandPrev = iBands(NULL,timeFrame,BBPrd,BBDev,0,PRICE_CLOSE,MODE_UPPER,y+1);
	   double BotBBandPrev = iBands(NULL,timeFrame,BBPrd,BBDev,0,PRICE_CLOSE,MODE_LOWER,y+1);
	   Buy[i]     = EMPTY_VALUE;
	   Sell[i]    = EMPTY_VALUE;
      Squeeze[i] = EMPTY_VALUE;
      if (TopBBand<TopSBand && BotBBand>BotSBand) Squeeze[i]=50;
      
      // ========= Squeeze Signals Ends
      
      // ========= BB Breakout Signals
      
      //if(Squeeze[shift+2]==50 && RSI[shift]>50 && BotBBand<BotSBand) 
      
      if((Squeeze[i+2]==50 || Squeeze[i+1]==50) && Rsi[i]>50 && BotBBand<BotSBand) 
      {
         Buy[i]=60;
         Sell[i]=EMPTY_VALUE;
      } 
      else 
      //if(Squeeze[shift+2]==50 && RSI[shift]<50 && TopBBand>TopSBand) 
      if((Squeeze[i+2]==50 || Squeeze[i+1]==50) && Rsi[i]<50 && TopBBand>TopSBand) 
      {
         Buy[i]=EMPTY_VALUE;
         Sell[i]=40;
      }
      else
      if(Buy[i+1]==60 && BotBBand<BotBBandPrev && Rsi[i]>50)
      {
         Buy[i]=60;
         Sell[i]=EMPTY_VALUE;
      } 
      else
      if(Sell[i+1]==40 && TopBBand>TopBBandPrev && Rsi[i]<50)
      {
         Buy[i]=EMPTY_VALUE;
         Sell[i]=40;
      }
      else
      {
         Buy[i]=EMPTY_VALUE;
         Sell[i]=EMPTY_VALUE;
      }
      
      // ========= BB Breakout Signals Ends
      
   }      
         

   // ======= Alert =========
   //
    //
    //
    //
    //
    
    if (alertsOn)
    {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      
      //
      //
      //
      //
      //
      
      if (Buy[whichBar+1]  == EMPTY_VALUE && Buy[whichBar]  != EMPTY_VALUE) doAlert(whichBar,"buy signal");
      if (Sell[whichBar+1] == EMPTY_VALUE && Sell[whichBar] != EMPTY_VALUE) doAlert(whichBar,"sell signal");
    }         
   return(0);  
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
      if (first[i+2] == EMPTY_VALUE) {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
         }
      else {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
         }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," RSI-TC ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " RSI-TC "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}






