

//*********************************************************************
          
//                 RSI with trend, colours and levels
//                     by ANGUS
                  
//*********************************************************************
#property  copyright "Copyright  2010, ANGUS"
#property  link      "http://www.forexfactory.com/"

#property indicator_separate_window
#property indicator_buffers 6

#property indicator_color1 White
#property indicator_color2 Lime
#property indicator_color3 Red
#property indicator_color4 Lime
#property indicator_color5 Red
#property indicator_color6 White

extern int       RSIPeriod=20;
extern int       DotSize =2;
extern int       UpLineValue=55;
extern int       DownLineValue=45;
extern color     UpLineColour=Black;
extern color     DownLineColour=Black;
extern color     MidLineColour=Silver;
extern int       LineStyle = 2;


double UpRSI[];
double DnRSI[];
double NoRSI[];
double UpLnRSI[];
double DnLnRSI[];
double NoLnRSI[];


int init() 
{

   IndicatorBuffers(6);
   
   
   SetIndexStyle(0,DRAW_LINE,0,1);
   SetIndexBuffer(0,NoLnRSI);
   
   SetIndexStyle(1,DRAW_LINE,0,1);
   SetIndexBuffer(1,UpLnRSI);
   
   SetIndexStyle(2,DRAW_LINE,0,1);
   SetIndexBuffer(2,DnLnRSI);
   
   SetIndexStyle(3,DRAW_ARROW,0,DotSize);
   SetIndexBuffer(3,UpRSI);
   SetIndexArrow(3,159);
   
   SetIndexStyle(4,DRAW_ARROW,0,DotSize);
   SetIndexBuffer(4,DnRSI);
   SetIndexArrow(4,159);
   
   SetIndexStyle(5,DRAW_ARROW,0,DotSize);
   SetIndexBuffer(5,NoRSI);
   SetIndexArrow(5,159);
   
   
          
   IndicatorShortName("RSI-TREND("+RSIPeriod+")");
   IndicatorDigits(2);
   
   return(0);
   
}


int start() 
{

   int counted_bars=IndicatorCounted();
   int shift,limit;
   int WindowIndex=WindowFind("RSI-TREND("+RSIPeriod+")");
   double RSIVal;
   static datetime prevtime = 0;
   
      
   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
   limit=Bars-31;
   if(counted_bars>=31) limit=Bars-counted_bars-1;

   for (shift=limit;shift>=0;shift--)   
   {
            
      RSIVal=iRSI(NULL,0,RSIPeriod,PRICE_CLOSE,shift);
      
      /// Colour coding
   
 UpRSI[shift]=RSIVal;//Green
 DnRSI[shift]=RSIVal;//Red
 NoRSI[shift]=RSIVal;//White  
 UpLnRSI[shift]=RSIVal;//Green
 DnLnRSI[shift]=RSIVal;//Red
 NoLnRSI[shift]=RSIVal;//White 
      
      if (RSIVal > UpLineValue)
       {
       DnRSI[shift]=EMPTY_VALUE;NoRSI[shift]=EMPTY_VALUE;
       DnLnRSI[shift]=EMPTY_VALUE;//NoLnRSI[shift]=EMPTY_VALUE;
       }
       
 else if (RSIVal < UpLineValue && RSIVal > DownLineValue)
       {
       DnRSI[shift]=EMPTY_VALUE;UpRSI[shift]=EMPTY_VALUE;
       DnLnRSI[shift]=EMPTY_VALUE;UpLnRSI[shift]=EMPTY_VALUE;
       }
 else 
       { 
       NoRSI[shift]=EMPTY_VALUE;UpRSI[shift]=EMPTY_VALUE;
       UpLnRSI[shift]=EMPTY_VALUE;//NoLnRSI[shift]=EMPTY_VALUE;
       }
      

   }    /// Lines and levels
    
     ObjectCreate( "RSI-Up", OBJ_HLINE, WindowIndex, 0, UpLineValue );
    ObjectSet( "RSI-Up", OBJPROP_COLOR, UpLineColour );
    ObjectSet( "RSI-Up", OBJPROP_STYLE, LineStyle);
    ObjectSet( "RSI-Up", OBJPROP_BACK, true );  
    
     ObjectCreate( "RSI-Mid", OBJ_HLINE, WindowIndex, 0, 50 );
    ObjectSet( "RSI-Mid", OBJPROP_COLOR, MidLineColour );
    ObjectSet( "RSI-Mid", OBJPROP_STYLE, LineStyle);
    ObjectSet( "RSI-Mid", OBJPROP_BACK, true );    
    
     ObjectCreate( "RSI-Low", OBJ_HLINE, WindowIndex, 0, DownLineValue );
    ObjectSet( "RSI-Low", OBJPROP_COLOR, DownLineColour );
    ObjectSet( "RSI-Low", OBJPROP_STYLE, LineStyle);
    ObjectSet( "RSI-Low", OBJPROP_BACK, true );      
      
   return(0);
   
}     /// Delete all lines

int deinit()
  {

   int WindowIndex=WindowFind("RSI-TREND("+RSIPeriod+")");
   
   ObjectsDeleteAll(WindowIndex,OBJ_HLINE); 

   return(0);
   
  } 