//+------------------------------------------------------------------+
//|                                              Step stochastic.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "www.forex-tsd.com"



#property indicator_separate_window
#property indicator_buffers    4
#property indicator_color1     Magenta
#property indicator_color2     Aqua
#property indicator_color3     LimeGreen
#property indicator_color4     Red
#property indicator_minimum    -1
#property indicator_maximum    101
#property indicator_level1     80
#property indicator_level2     20
#property indicator_levelcolor Olive

//
//
//
//
//
extern string TimeFrame              = "Current time frame";
extern int    UsePrice               = PRICE_MEDIAN;
extern double Atr.Length             = 10;
extern double Atr.SmoothPhase        = 0;
extern bool   Atr.SmoothDouble       = true;
extern double K.Slow                 = 1;
extern double K.Fast                 = 1;
extern double StepSto.SmoothLength   = 5.0;
extern double StepSto.SmoothPhase    = 0;
extern bool   StepSto.SmoothDouble   = true;
extern int    Window                 = 256;
extern bool   Interpolate            = true;

extern string note                   = "turn on Alert = true; turn off = false";
extern bool   alertsOn               = true;
extern bool   alertsOnCurrent        = true;
extern bool   alertsMessage          = true;
extern bool   alertsSound            = true;
extern bool   alertsEmail            = false;
extern string soundfile              = "alert2.wav";

extern int    ArrowSize              = 2;
extern bool   verticalLinesVisible   = true;
extern string verticalLinesID        = "StepStochLines";
extern color  verticalLinesUpColor   = DeepSkyBlue;
extern color  verticalLinesDownColor = PaleVioletRed;
extern int    verticalLinesStyle     = STYLE_DOT;
extern int    verticalLinesWidth     = 0;

//
//
//
//
//

double stoch1[];
double stoch2[];
double CrossUp[];
double CrossDn[];
double trend[];
double atr[];



string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,stoch2);
   SetIndexBuffer(1,stoch1);
   SetIndexBuffer(2,CrossUp); SetIndexStyle(2,DRAW_ARROW,0,ArrowSize); SetIndexArrow(2,225);
   SetIndexBuffer(3,CrossDn); SetIndexStyle(3,DRAW_ARROW,0,ArrowSize); SetIndexArrow(3,226);      
   SetIndexBuffer(4,atr);
   SetIndexBuffer(5,trend);
   
   indicatorFileName = WindowExpertName();
   calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
   returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
   
   
      
   IndicatorShortName(timeFrameToString(timeFrame)+"  Smoothed Step stochastic )"+Atr.Length+","+DoubleToStr(K.Slow,2)+","+DoubleToStr(K.Fast,2)+","+Window+")");
   
   
   return(0);
}



int deinit()
{
   string lookFor       = verticalLinesID+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}


//
//
//
//
//

double work[][12];
#define k.SminMin   0
#define k.SmaxMin   1
#define k.SminMid   2
#define k.SmaxMid   3
#define k.SminMax   4
#define k.SmaxMax   5
#define k.TrendMin  6
#define k.TrendMid  7
#define k.TrendMax  8
#define k.linemin   9 
#define k.linemid  10
#define k.linemax  11
#define bigValue   99999999

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { stoch2[0] = limit+1; return(0); }
   
   //
   //
   //
   //
   //

           if (calculateValue || timeFrame==Period())
           {    
     
           
           if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

   for(i=limit, r=Bars-limit-1; i>=0; i--,r++)
   {
      double nPrice = iMA(NULL,0,1,0,MODE_SMA,UsePrice,i);  
             atr[i] = iCustom(NULL,0,"Atr on jurik",Atr.Length,Atr.SmoothPhase,Atr.SmoothDouble,0,i); 
             if (r<=Window)
             {
                  work[r][k.TrendMin] = 0;
                  work[r][k.TrendMid] = 0;
                  work[r][k.TrendMax] = 0;
                  work[r][k.linemin]  = 0;
                  work[r][k.linemid]  = 0;
                  work[r][k.linemax]  = 0;
                  work[r][k.SminMin]  = bigValue;
                  work[r][k.SmaxMin]  = bigValue;
                  work[r][k.SminMax]  = 0;
                  work[r][k.SmaxMax]  = 0;
                  work[r][k.SminMid]  = 0;
                  work[r][k.SmaxMid]  = 0;
                  continue;
             }

      //
      //
      //
      //
      //
      
         double nATRmax     = atr[ArrayMaximum(atr,Window,i)];
         double nATRmin     = atr[ArrayMinimum(atr,Window,i)];
         double StepSizeMin = (K.Fast * nATRmin);
         double StepSizeMax = (K.Fast * nATRmax);
         double StepSizeMid = (K.Fast * 0.5 * K.Slow * (nATRmax + nATRmin));

            work[r][k.SmaxMin] = nPrice + 2.0 * StepSizeMin;
            work[r][k.SminMin] = nPrice - 2.0 * StepSizeMin;
            work[r][k.SmaxMax] = nPrice + 2.0 * StepSizeMax;
            work[r][k.SminMax] = nPrice - 2.0 * StepSizeMax;
            work[r][k.SmaxMid] = nPrice + 2.0 * StepSizeMid;
            work[r][k.SminMid] = nPrice - 2.0 * StepSizeMid;

            //
            //
            //
            //
            //
         
            double TrendMin = work[r-1][k.TrendMin];
            double TrendMid = work[r-1][k.TrendMid];
            double TrendMax = work[r-1][k.TrendMax];
            double linemin  = work[r-1][k.linemin];
            double linemid  = work[r-1][k.linemid];
            double linemax  = work[r-1][k.linemax];

            //
            //
            //
            //
            //
                        
            if (nPrice > work[r-1][k.SmaxMin]) TrendMin =  1;
            if (nPrice < work[r-1][k.SminMin]) TrendMin = -1;
            if (nPrice > work[r-1][k.SmaxMax]) TrendMax =  1;
            if (nPrice < work[r-1][k.SminMax]) TrendMax = -1;
            if (nPrice > work[r-1][k.SmaxMid]) TrendMid =  1;
            if (nPrice < work[r-1][k.SminMid]) TrendMid = -1;

            if (TrendMin > 0 && work[r][k.SminMin] < work[r-1][k.SminMin]) work[r][k.SminMin] = work[r-1][k.SminMin];
            if (TrendMin < 0 && work[r][k.SmaxMin] > work[r-1][k.SmaxMin]) work[r][k.SmaxMin] = work[r-1][k.SmaxMin];
            if (TrendMax > 0 && work[r][k.SminMax] < work[r-1][k.SminMax]) work[r][k.SminMax] = work[r-1][k.SminMax];
            if (TrendMax < 0 && work[r][k.SmaxMax] > work[r-1][k.SmaxMax]) work[r][k.SmaxMax] = work[r-1][k.SmaxMax];
            if (TrendMid > 0 && work[r][k.SminMid] < work[r-1][k.SminMid]) work[r][k.SminMid] = work[r-1][k.SminMid];
            if (TrendMid < 0 && work[r][k.SmaxMid] > work[r-1][k.SmaxMid]) work[r][k.SmaxMid] = work[r-1][k.SmaxMid];

            if (TrendMin > 0) linemin = work[r][k.SminMin] + StepSizeMin;
            if (TrendMin < 0) linemin = work[r][k.SmaxMin] - StepSizeMin;
            if (TrendMax > 0) linemax = work[r][k.SminMax] + StepSizeMax;
            if (TrendMax < 0) linemax = work[r][k.SmaxMax] - StepSizeMax;
            if (TrendMid > 0) linemid = work[r][k.SminMid] + StepSizeMid;
            if (TrendMid < 0) linemid = work[r][k.SmaxMid] - StepSizeMid;

         //
         //
         //
         //
         //
               
         work[r][k.TrendMin] = TrendMin;
         work[r][k.TrendMid] = TrendMid;
         work[r][k.TrendMax] = TrendMax;
         work[r][k.linemin]  = linemin;
         work[r][k.linemid]  = linemid;
         work[r][k.linemax]  = linemax;
            
         //
         //
         //
         //
         //
         
         double bsmin = linemax - StepSizeMax;
         double bsmax = linemax + StepSizeMax;
         if (bsmax!=bsmin)
         {
            stoch1[i] = iDSmooth(((linemin - bsmin) / (bsmax - bsmin)) * 100.0,StepSto.SmoothLength,StepSto.SmoothPhase,StepSto.SmoothDouble,i, 0);
            stoch2[i] = iDSmooth(((linemid - bsmin) / (bsmax - bsmin)) * 100.0,StepSto.SmoothLength,StepSto.SmoothPhase,StepSto.SmoothDouble,i,20);
            
         }
         else               
         {
            stoch1[i]  = iDSmooth(0,StepSto.SmoothLength,StepSto.SmoothPhase,StepSto.SmoothDouble,i, 0);
            stoch2[i]  = iDSmooth(0,StepSto.SmoothLength,StepSto.SmoothPhase,StepSto.SmoothDouble,i,20);  
         }
           trend[i]   = trend[i+1];
           CrossUp[i] = EMPTY_VALUE;
           CrossDn[i] = EMPTY_VALUE;  
      
           
         if (stoch1[i] > stoch2[i] && stoch1[i+1] <= stoch2[i+1]) trend[i] =  1;
         if (stoch1[i] < stoch2[i] && stoch1[i+1] >= stoch2[i+1]) trend[i] = -1;
          manageLines(i);
          
         
         CrossUp[i] = EMPTY_VALUE;
         CrossDn[i] = EMPTY_VALUE;
         if (trend[i] !=trend[i+1])
         if (trend[i] == 1)
               CrossUp[i] = stoch2[i];
         else  CrossDn[i] = stoch2[i];
         }
         
   manageAlerts();
   return(0);
}

limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
      int y      = iBarShift(NULL,timeFrame,Time[i]);
      stoch2[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",UsePrice,Atr.Length,Atr.SmoothPhase,Atr.SmoothDouble,K.Slow,K.Fast,StepSto.SmoothLength,StepSto.SmoothPhase,StepSto.SmoothDouble,Window,verticalLinesVisible,0,y);
      stoch1[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",UsePrice,Atr.Length,Atr.SmoothPhase,Atr.SmoothDouble,K.Slow,K.Fast,StepSto.SmoothLength,StepSto.SmoothPhase,StepSto.SmoothDouble,Window,verticalLinesVisible,1,y);
      CrossUp[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",UsePrice,Atr.Length,Atr.SmoothPhase,Atr.SmoothDouble,K.Slow,K.Fast,StepSto.SmoothLength,StepSto.SmoothPhase,StepSto.SmoothDouble,Window,verticalLinesVisible,2,y);
      CrossDn[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",UsePrice,Atr.Length,Atr.SmoothPhase,Atr.SmoothDouble,K.Slow,K.Fast,StepSto.SmoothLength,StepSto.SmoothPhase,StepSto.SmoothDouble,Window,verticalLinesVisible,3,y);
      atr[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",UsePrice,Atr.Length,Atr.SmoothPhase,Atr.SmoothDouble,K.Slow,K.Fast,StepSto.SmoothLength,StepSto.SmoothPhase,StepSto.SmoothDouble,Window,verticalLinesVisible,4,y);
      trend[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",UsePrice,Atr.Length,Atr.SmoothPhase,Atr.SmoothDouble,K.Slow,K.Fast,StepSto.SmoothLength,StepSto.SmoothPhase,StepSto.SmoothDouble,Window,verticalLinesVisible,5,y);
      
       manageLines(i);
       
      if (timeFrame <= Period() || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
         if (!Interpolate) continue;

         

         datetime time = iTime(NULL,timeFrame,y);
         for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
         double factor = 1.0 / n;
         for(int j = 1; j < n; j++)
         {
  	      stoch2[i+j]  = j*factor*stoch2[i+n]  + (1.0-j*factor)*stoch2[i];
  	      stoch1[i+j]  = j*factor*stoch1[i+n]  + (1.0-j*factor)*stoch1[i];
  	      CrossUp[i+j] = j*factor*CrossUp[i+n] + (1.0-j*factor)*CrossUp[i];
  	      CrossDn[i+j] = j*factor*CrossDn[i+n] + (1.0-j*factor)*CrossDn[i];
  	     
        }  	            
     }
    
     manageAlerts(); 
    
   return(0);
}


void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" smoothed step sto trend changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," smoothed step sto "),message);
          if (alertsSound)   PlaySound(soundfile);
   }
}




string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

void manageLines(int i)
{
   if (!calculateValue && verticalLinesVisible )
   {
         deleteLine(Time[i]);
         if (trend[i]!=trend[i+1])
         {
            if (trend[i] == 1) drawLine(i,verticalLinesUpColor);
            if (trend[i] ==-1) drawLine(i,verticalLinesDownColor);
         }
   }
}               

//
//
//
//
//

void drawLine(int i,color theColor)
{
   string name = verticalLinesID+":"+Time[i];
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_VLINE,0,Time[i],0);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_STYLE,verticalLinesStyle);
         ObjectSet(name,OBJPROP_WIDTH,verticalLinesWidth);
         ObjectSet(name,OBJPROP_BACK,true);
}

//
//
//
//
//

void deleteLine(datetime time)
{
   string lookFor = verticalLinesID+":"+time; ObjectDelete(lookFor);
}



double wrk[][40];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}