//+------------------------------------------------------------------+
//|                                                   SwingZZ_TL.mq4 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 Aqua
#property indicator_color2 Blue
#property indicator_color3 Red
#property indicator_width4 2 
#property indicator_color4 Lime
#property indicator_color5 Red
#property indicator_width5 2
extern int NBars=200;
extern int SwingMinBars=2;
extern int PipsPast=1;
extern bool ShowLabels=true;
extern bool EnableAlert=true;
extern bool MailNotification=false;
extern bool MobileNotification=false;
double swingTop[],swingBottom[],swingLine[],buySignal[],sellSignal[];
string ver="SwingZZ_TL";
int multiplier=1;
 int idx1,idx2;
    datetime lastBuy=0;
    datetime lastSell=0;
  
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexBuffer(1,swingTop);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,164);
   SetIndexBuffer(2,swingBottom);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,164);
   SetIndexBuffer(0,swingLine);
   SetIndexStyle(0,DRAW_SECTION);
   
   SetIndexBuffer(3,buySignal);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,233);
   SetIndexBuffer(4,sellSignal);
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(4,234);
   if(Digits==3||Digits==5)multiplier=10;
   idx1=0;
   idx2=0;
   lastBuy=0;
   lastSell=0;
   //---
   return(0);
  }
   
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   for(int i=ObjectsTotal()-1;i>=0;i--){
      string n=ObjectName(i);
      if(StringFind(n,ver,0)>=0)ObjectDelete(n);
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   
   if(Bars<NBars)NBars=Bars;
   int i=NBars;
   double lastSignalBuy=0;
   double lastSignalSell=0;
   while(i>=0){
      int firstBlueDot=getBlueDot(i);
      int firstRedDot=getRedDot(i);
      buySignal[i]=EMPTY_VALUE;
      sellSignal[i]=EMPTY_VALUE;
      swingLine[i]=EMPTY_VALUE;
      swingTop[i]=iCustom(Symbol(),0,"swing_zz",SwingMinBars,1,i);
      swingBottom[i]=iCustom(Symbol(),0,"swing_zz",SwingMinBars,2,i);
      swingLine[firstRedDot]=iCustom(Symbol(),0,"swing_zz",SwingMinBars,2,firstRedDot);
         swingLine[firstBlueDot]=iCustom(Symbol(),0,"swing_zz",SwingMinBars,1,firstBlueDot);
      if(firstBlueDot<firstRedDot){
         int bIndex1=getBlueDot(firstBlueDot+1);
         int bIndex2=getBlueDot(bIndex1+1);
         int rIndex1=firstRedDot;
         int rIndex2=getRedDot(rIndex1+1);
        
      }else{
         bIndex1=firstBlueDot;
         bIndex2=getBlueDot(bIndex1+1);
         rIndex1=getRedDot(firstRedDot+1);
         rIndex2=getRedDot(rIndex1+1);
         //swingLine[firstRedDot]=iCustom(Symbol(),0,"swing_zz",SwingMinBars,1,firstRedDot);
         //swingLine[firstBlueDot]=iCustom(Symbol(),0,"swing_zz",SwingMinBars,2,firstBlueDot);
      }
      double h1=High[bIndex1];
      double h2=High[bIndex2];
      double l1=Low[rIndex1];
      double l2=Low[rIndex2];
      double range=High[i]-Low[i];
      drawTrendLine(ver+"Down",Time[bIndex1],h1,Time[i],h1,true,indicator_color4);
      drawTrendLine(ver+"Up",Time[rIndex1],l1,Time[i],l1,true,indicator_color5);
      double currDown=ObjectGetValueByShift(ver+"Down",i+1);
      double currUp=ObjectGetValueByShift(ver+"Up",i+1);
      if(currDown>0&&Close[i+2]<=currDown&&Close[i+1]>=currDown+PipsPast*multiplier*Point){
         buySignal[i+1]=High[i+1];
         if(lastBuy<Time[i+1]){
            lastBuy=Time[i+1];
            idx1++;
            if(i==0)displayMessage("Buy signal");
            lastSignalBuy=Close[i+1];
            drawTrendLine(ver+"D"+idx1,Time[bIndex1],h1,Time[i],h1,False,indicator_color4,STYLE_DOT);
            int fIdx=MathMax(firstBlueDot,firstRedDot)-i;
            int fIdx2=iLowest(Symbol(),0,MODE_LOW,fIdx,i+1);
            double slBuy=Low[fIdx2];
            if(ShowLabels){
               drawTrendLine(ver+"SLBuy"+idx1,Time[fIdx2],slBuy,Time[i],slBuy,False,Blue);
               drawText(ver+"tSLBuy"+idx1,"SL Buy #"+idx1,Time[i+1],slBuy,White,ANCHOR_UPPER,325);
               drawText(ver+"Buy"+idx1,"Buy #"+idx1,Time[i+1],High[i+1]+range*0.5,indicator_color4,ANCHOR_UPPER,125);
            }
         }
      }
      if(currUp>0&&Close[i+2]>=currUp&&Close[i+1]<=currUp-PipsPast*multiplier*Point){
         sellSignal[i+1]=Low[i+1];
         if(lastSell<Time[i+1]){
            lastSell=Time[i+1];
            idx2++;
            if(i==0)displayMessage("Sell signal");
            lastSignalSell=Close[i+1];
           drawTrendLine(ver+"U"+idx2,Time[rIndex1],l1,Time[i]+Period()*3,l1,False,indicator_color5,STYLE_DOT);
            fIdx=MathMax(firstBlueDot,firstRedDot)-i;
            fIdx2=iHighest(Symbol(),0,MODE_HIGH,fIdx,i+1);
            double slSell=High[fIdx2];
            if(ShowLabels){
               drawTrendLine(ver+"SLSell"+idx2,Time[fIdx2],slSell,Time[i],slSell,False,Blue);
               drawText(ver+"tSLSell"+idx2,"SL Sell #"+idx2,Time[i+1],slSell,White,ANCHOR_RIGHT,45);
               drawText(ver+"Sell"+idx2,"Sell #"+idx2,Time[i+1],Low[i+1]-range*0.5,indicator_color5,ANCHOR_RIGHT,225);
            }
         }
      }
     
      i--;
   }
//----
   Comment(firstBlueDot,"__",firstRedDot);
//----
   return(0);
  }
//+------------------------------------------------------------------+
int getRedDot(int begin){
   double retVal;
   int k=0;
   for(int i=begin;i<Bars;i++){
      k++;
      retVal=iCustom(Symbol(),0,"swing_zz",SwingMinBars,2,i);
      if(retVal!=EMPTY_VALUE&&retVal>0){
         return(i);
      }
   }
   return(-1);
}
int getBlueDot(int begin){
   double retVal;
   int k=0;
   for(int i=begin;i<Bars;i++){
      k++;
      retVal=iCustom(Symbol(),0,"swing_zz",SwingMinBars,1,i);
      if(retVal!=EMPTY_VALUE&&retVal>0){
         return(i);
      }
   }
   return(-1);
}
void drawTrendLine(string name, datetime t1, double pr1, datetime t2, double pr2,bool isRay, color c,int style=STYLE_SOLID){
   ObjectDelete(0,name);
   ObjectCreate(name,OBJ_TREND,0,0,0,0,0,0,0);
   ObjectSet(name,OBJPROP_TIME1,t1);
   ObjectSet(name,OBJPROP_PRICE1,pr1);
   ObjectSet(name,OBJPROP_TIME2,t2);
   ObjectSet(name,OBJPROP_PRICE2,pr2);
    ObjectSet(name,OBJPROP_COLOR,c);
    ObjectSet(name,OBJPROP_RAY,isRay);
    ObjectSet(name,OBJPROP_STYLE,style);
    ObjectSetInteger(0,name,OBJPROP_SELECTABLE,true);
} 

void displayMessage(string msg){
      if(EnableAlert)Alert(msg," on ",periodToString(Period())," of ",Symbol()," pair");
      string header="From SwingZZ_TL Indicator";
      string txt=msg+" on "+periodToString(Period())+" of "+Symbol()+" pair";
      if(MailNotification)SendMail(header,txt);
      txt=header+" "+msg+" on "+periodToString(Period())+" of "+Symbol()+" pair";
      if(MobileNotification)SendNotification(txt);
 }
  
 string periodToString(int p){
   if(p==1)return ("M1");
   if(p==5)return ("M5");
   if(p==15)return ("M15");
   if(p==30)return ("M30");
   if(p==60)return ("H1");
   if(p==240)return ("H4");
   if(p==1440)return ("D1");
   if(p==10080)return ("W1");
   if(p==43200)return ("Monthly");
   return("Unknown Period");
}
void drawText(string name,string txt,datetime t, double p, color c, int anch,double dgr){
   ObjectCreate(0,name,OBJ_TEXT,0,0,0);
   ObjectSet(name,OBJPROP_PRICE1,p);
   ObjectSet(name,OBJPROP_TIME1,t);
   ObjectSetText(name,txt,9,"Tahoma",c);
   ObjectSetInteger(0,name,OBJPROP_ANCHOR,ANCHOR_LEFT_LOWER);
   ObjectSet(name,OBJPROP_ANGLE,dgr);
}