//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  LimeGreen
#property indicator_color4  Orange
#property indicator_color5  EMPTY
#property indicator_color6  Lime
#property indicator_color7  DarkGray
#property indicator_color8  Gold
#property indicator_style7  STYLE_DOT
#property indicator_width1  3
#property indicator_width2  3
#property indicator_width3  3
#property indicator_width4  3
#property indicator_width5  3
#property indicator_width6  2
#property indicator_width8  2
#import "user32.dll"
   int GetDC(int hwnd);
   int ReleaseDC(int hwnd,int hdc);
#import "gdi32.dll"
   color GetPixel(int hdc,int x,int y);

//
//
//
//
//

extern double T3Period    =  25;
extern double T3Hot       =  0.7;
extern bool   T3Original  =  false;

double ssm[];
double fill[];
double ssmu[];
double ssmd[];
double ssmh1[];
double ssmh2[];
double ssml1[];
double ssml2[];
double slope1[];
double slope2[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(10);
   SetIndexBuffer(0,ssmh1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ssmh2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ssml1); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,ssml2); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,fill);  SetIndexStyle(4,DRAW_HISTOGRAM);
   SetIndexBuffer(5,ssmu);
   SetIndexBuffer(6,ssm);
   SetIndexBuffer(7,ssmd);
   SetIndexBuffer(8,slope1);
   SetIndexBuffer(9,slope2);
   
   IndicatorShortName ("t3 double bands");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int hwnd = WindowHandle(Symbol(),Period());
   int hdc  = GetDC(hwnd);
      color back_ground = GetPixel(hdc,1,2); ReleaseDC(hwnd,hdc);
         SetIndexStyle(4,DRAW_HISTOGRAM,0,EMPTY,back_ground);

   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   //

   for(int i=limit; i >= 0; i--)
   {
         ssm[i]    = iT3(iMA(NULL,0,1,0,MODE_SMA,PRICE_CLOSE,i),T3Period,T3Hot,T3Original,i,0);
         ssmu[i]   = iT3(iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH ,i),T3Period,T3Hot,T3Original,i,1);
         ssmd[i]   = iT3(iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW  ,i),T3Period,T3Hot,T3Original,i,2);
         fill[i]   = ssmd[i];
         slope1[i] = slope1[i+1];
         slope2[i] = slope2[i+1];
            if (ssmu[i]>ssmu[i+1]) slope1[i] =  1;
            if (ssmu[i]<ssmu[i+1]) slope1[i] = -1;
            if (ssmd[i]>ssmd[i+1]) slope2[i] =  1;
            if (ssmd[i]<ssmd[i+1]) slope2[i] = -1;
            if (slope1[i] == 1)
            {
               ssmh1[i] = ssmu[i];
               ssmh2[i] = ssm[i];
            }
            else
            {
               ssmh2[i] = ssmu[i];
               ssmh1[i] = ssm[i];
            }               
            if (slope2[i] == 1)
            {
               ssml2[i] = ssmd[i];
               ssml1[i] = ssm[i];
            }
            else
            {
               ssml1[i] = ssmd[i];
               ssml2[i] = ssm[i];
            }
                           
   }   
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workT3[][18];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workT3,0) != Bars)                ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (instanceNo+1)) ArrayResize(workT3Coeffs,instanceNo+1);

   if (workT3Coeffs[instanceNo][_period] != period)
   {
     workT3Coeffs[instanceNo][_period] = period;
        double a = hot;
            workT3Coeffs[instanceNo][_c1] = -a*a*a;
            workT3Coeffs[instanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[instanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[instanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[instanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[instanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[instanceNo][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[instanceNo][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[instanceNo][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[instanceNo][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[instanceNo][_c4]*workT3[r][2+buffer]);
}