
//+------------------------------------------------------------------+
//| t_ma.mq4 |
//| |
//| |
//+------------------------------------------------------------------+
#property copyright ""
#property link ""

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 MediumBlue
#property indicator_color2 Blue
#property indicator_color3 DodgerBlue
#property indicator_color4 DeepSkyBlue
#property indicator_color5 SkyBlue
#property indicator_color6 Aqua
#property indicator_color7 Aquamarine
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 1
#property indicator_width6 1
#property indicator_width7 1


extern int                HMA_Period       = 100;
extern ENUM_APPLIED_PRICE HMA_PriceType    = 0;
extern ENUM_MA_METHOD     HMA_Method       = 3;
extern int                ad1 = 2;
extern int ad2 = 4;
extern int ad3 = 6;
extern int ad4 = 8;
extern int ad5 = 10;


double ExtMapBuffer0[];
double ExtMapBuffer1[];
double ExtMapBuffer2[];double ExtMapBuffer3[];
double ExtMapBuffer4[];double ExtMapBuffer5[];
double ExtMapBuffer6[];double ExtMapBuffer7[];

int HalfPeriod;
int HullPeriod;

//+------------------------------------------------------------------+
//| Custom indicator initialization function |
//+------------------------------------------------------------------+
int init()
{
IndicatorBuffers(8);
SetIndexBuffer(0,ExtMapBuffer1);
SetIndexBuffer(1,ExtMapBuffer2);
SetIndexBuffer(2,ExtMapBuffer3);
SetIndexBuffer(3,ExtMapBuffer4);
SetIndexBuffer(4,ExtMapBuffer5);
SetIndexBuffer(5,ExtMapBuffer6);
SetIndexBuffer(6,ExtMapBuffer7);
SetIndexBuffer(7,ExtMapBuffer0);
HMA_Period = MathMax(2,HMA_Period);
HalfPeriod = MathFloor(HMA_Period/2);
HullPeriod = MathFloor(MathSqrt(HMA_Period));

//----
return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function |
//+------------------------------------------------------------------+
int deinit()
{
//----

//----
return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function |
//+------------------------------------------------------------------+
int start()
{
int i,counted_bars=IndicatorCounted();
if(counted_bars<0) return(-1);
if(counted_bars>0) counted_bars--;
int limit = MathMin(Bars-counted_bars,Bars-1);
if (ad1<0) limit=MathMax(limit,-ad1);
if (ad2<0) limit=MathMax(limit,-ad2);
if (ad3<0) limit=MathMax(limit,-ad3);
if (ad4<0) limit=MathMax(limit,-ad4);
if (ad5<0) limit=MathMax(limit,-ad5);



for(i=limit;i>=0;i--) ExtMapBuffer0[i]=iMA(NULL,0,HalfPeriod,0,HMA_Method,HMA_PriceType,i)*2-iMA(NULL,0,HMA_Period,0,HMA_Method,HMA_PriceType,i);
for(i=limit;i>=0;i--)
{
ExtMapBuffer1[i] = iMAOnArray(ExtMapBuffer0,0,HullPeriod,0,HMA_Method,i);
ExtMapBuffer2[i]=(ExtMapBuffer1[i]+ExtMapBuffer1[i+1]+ExtMapBuffer1[i+2]+ExtMapBuffer1[i+3]+ExtMapBuffer1[i+4]+ExtMapBuffer1[i+5])/6.0;
}
for(i=limit;i>=0;i--)
{

ExtMapBuffer3[i]= ExtMapBuffer2[i+ad1]; if (ExtMapBuffer3[i]==0) ExtMapBuffer3[i]=EMPTY_VALUE;
ExtMapBuffer4[i]= ExtMapBuffer2[i+ad2]; if (ExtMapBuffer4[i]==0) ExtMapBuffer4[i]=EMPTY_VALUE;
ExtMapBuffer5[i]= ExtMapBuffer2[i+ad3]; if (ExtMapBuffer5[i]==0) ExtMapBuffer5[i]=EMPTY_VALUE;
ExtMapBuffer6[i]= ExtMapBuffer2[i+ad4]; if (ExtMapBuffer6[i]==0) ExtMapBuffer6[i]=EMPTY_VALUE;
ExtMapBuffer7[i]= ExtMapBuffer2[i+ad5]; if (ExtMapBuffer7[i]==0) ExtMapBuffer7[i]=EMPTY_VALUE;
}
//----
return(0);
}
//+--