//+------------------------------------------------------------------+
//|                                                     BucRiver.mq4 |
//|                                    Copyright  2007, Petr Kouril |
//|                                           http://www.jaktrade.cz |
//+------------------------------------------------------------------+

#property copyright "Copyright  2007, Petr Kouril"
#property link      "http://www.jaktrade.cz"

// Needed Custom Indicator
// Slope Direction Line.mq4
// MACDSmoothed.mq4
// SuperWoodieCCI_alert.mq4

#property indicator_chart_window
#property indicator_buffers  6
#property indicator_color1 Red
#property indicator_color2 LimeGreen
#property indicator_color3 Red
#property indicator_color4 LimeGreen
#property indicator_color5 Red
#property indicator_color6 LimeGreen

//---- input parameters
int					TimeFrame        = 0;

bool					AlertPossible    = true;
bool					SendMailPossible = true;
int					LastAlertTime    = 0;

//---- buffers
double EnterLong1[];
double EnterShort1[];
double EnterLong2[];
double EnterShort2[];
double EnterLong3[];
double EnterShort3[];

int init()
{
	SetIndexStyle (0, DRAW_HISTOGRAM);
   SetIndexBuffer(0, EnterShort1);
   SetIndexStyle (1, DRAW_HISTOGRAM);
   SetIndexBuffer(1, EnterLong1);
	SetIndexStyle (2, DRAW_HISTOGRAM);
   SetIndexBuffer(2, EnterShort2);
   SetIndexStyle (3, DRAW_HISTOGRAM);
   SetIndexBuffer(3, EnterLong2);
	SetIndexStyle (4, DRAW_HISTOGRAM);
   SetIndexBuffer(4, EnterShort3);
   SetIndexStyle (5, DRAW_HISTOGRAM);
   SetIndexBuffer(5, EnterLong3);

   return(0);
}

int deinit()
{
   return(0);
}

int start()
{
	int limit;
	int C_MA, C_SDL, C_MACD, C_CCI, C_RSI, C_SRSI;
	int Shorts, Longs;
	
   int counted_bars = IndicatorCounted();
   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
   limit = Bars-counted_bars;

   for(int i = 0; i < limit; i++)
   {
   	Longs  = 0;
   	Shorts = 0;
   	
   	C_MA   = CheckMA  (i, Longs, Shorts);
   	C_SDL  = CheckSDL (i, Longs, Shorts);
   	C_MACD = CheckMACD(i, Longs, Shorts);
   	C_CCI  = CheckCCI (i, Longs, Shorts);
   	C_RSI  = CheckRSI (i, Longs, Shorts);
   	C_SRSI = CheckSRSI(i, Longs, Shorts);

      EnterLong3[i]  = EMPTY_VALUE;
      EnterShort3[i] = EMPTY_VALUE;
      EnterLong2[i]  = EMPTY_VALUE;
      EnterShort2[i] = EMPTY_VALUE;
      EnterLong1[i]  = EMPTY_VALUE;
      EnterShort1[i] = EMPTY_VALUE;
		if ((Longs  == 4) && (C_MACD ==  1))
			{ EnterLong3[i]  = High[i]; EnterShort3[i] = Low[i]; }
		if ((Shorts == 4) && (C_MACD == -1)) 
			{ EnterLong3[i]  = Low[i]; EnterShort3[i] = High[i]; }

		if (Longs == 5)
			{ EnterLong2[i]  = High[i]; EnterShort2[i] = Low[i]; }
		if (Shorts == 5)
			{ EnterLong2[i]  = Low[i]; EnterShort2[i] = High[i]; }
				
		if (Longs == 6)
			{ EnterLong1[i]  = High[i]; EnterShort1[i] = Low[i]; }
		if (Shorts == 6)
			{ EnterLong1[i]  = Low[i]; EnterShort1[i] = High[i]; }
/*   	
   	if (C_SRSI == 1)
			EnterLong[i]  = Longs;
   	if (C_SRSI == -1)
			EnterShort[i] = Shorts	; 
*/
   }
   return(0);
}

int CheckMA(int Shift, int &Longs, int &Shorts)
{
	double MA = iMA(NULL, TimeFrame, 5, 0, MODE_EMA, PRICE_CLOSE, Shift) - iMA(NULL, TimeFrame, 12, 0, MODE_EMA, PRICE_CLOSE, Shift);
	if (MA > 0) {Longs++;  return (1);}
	if (MA < 0) {Shorts++; return (-1);}
	return (0);
}

int CheckSDL(int Shift, int &Longs, int &Shorts)
{
	double UpTrend = iCustom(NULL, TimeFrame, "Slope Direction Line", 60, 3, 0, 0, Shift);
	double DnTrend = iCustom(NULL, TimeFrame, "Slope Direction Line", 60, 3, 0, 1, Shift);
	
	if (UpTrend != EMPTY_VALUE) {Longs++;  return (1);}
	if (DnTrend != EMPTY_VALUE) {Shorts++; return (-1);}
	
	return (0);
}

int CheckMACD(int Shift, int &Longs, int &Shorts)
{
	double FastMACD = iCustom(NULL, TimeFrame, "MACDsmoothed", 5, 13, 2, 0, Shift);
	double SlowMACD = iCustom(NULL, TimeFrame, "MACDsmoothed", 5, 13, 2, 1, Shift);

	if (FastMACD > SlowMACD) {Longs++;  return (1);}
	if (FastMACD < SlowMACD) {Shorts++; return (-1);}
	return (0);
}

int CheckCCI(int Shift, int &Longs, int &Shorts)
{
	double CCI = iCustom(NULL, TimeFrame, "SuperWoodieCCI_alert", 50, 0, false, 0, Shift);

	if (CCI >  50) {Longs++;  return (1);}
	if (CCI < -50) {Shorts++; return (-1);}
	return (0);
}

int CheckRSI(int Shift, int &Longs, int &Shorts)
{
	double RSI = iRSI(NULL, TimeFrame, 21, PRICE_CLOSE, Shift);
	
	if (RSI >  50) {Longs++;  return (1);}
	if (RSI <  50) {Shorts++; return (-1);}
	return (0);
}

int CheckSRSI(int Shift, int &Longs, int &Shorts)
{
	double SRSI = iCustom(NULL, TimeFrame, "StepRSI_v2 with Alert", 18, 5, 10, false, 1, Shift) - iCustom(NULL, TimeFrame, "StepRSI_v2 with Alert", 18, 5, 10, false, 2, Shift);
	
	if (SRSI >  0) {Longs++;  return (1);}
	if (SRSI <  0) {Shorts++; return (-1);}
	return (0);
}

/*
void MakeAlert(string Notice, int Index)
{
	datetime AlertTimeOut = iTime(NULL, TimeFrame, 1) - iTime(NULL, TimeFrame, 2);
	
	if (Index >= 2) return;
	if ((TimeCurrent() - LastAlertTime) < AlertTimeOut) return;

	if (AlertPossible)    {PlaySound("alert2.wav"); Alert(Notice);}
	if (SendMailPossible) SendMail(Notice, "");
	LastAlertTime = TimeCurrent();
}
*/