//+------------------------------------------------------------------+
//|                                                 TTM original.mq4 |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 LightGray
#property indicator_color2 LightGray
#property indicator_color3 Red
#property indicator_color4 LimeGreen
#property indicator_color5 Yellow
#property indicator_color6 Yellow
#property indicator_color7 Yellow
#property indicator_color8 Yellow
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2
#property indicator_width6 2
#property indicator_width7 3
#property indicator_width8 3

//
//
//
//
//

extern int Length = 50;
extern int Price  = PRICE_CLOSE;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double buffer6[];
double buffer7[];
double buffer8[];

double alphas[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,buffer3); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,buffer4); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,buffer5); SetIndexStyle(4,DRAW_HISTOGRAM);
   SetIndexBuffer(5,buffer6); SetIndexStyle(5,DRAW_HISTOGRAM);
   SetIndexBuffer(6,buffer7); SetIndexStyle(6,DRAW_HISTOGRAM);
   SetIndexBuffer(7,buffer8); SetIndexStyle(7,DRAW_HISTOGRAM);
   return(0);
}

//
//
//
//
//

int deinit()
{
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
 
   //
   //
   //
   //
   //
            
   for (i=limit; i>=0; i--)
   {  
      double median = iNoLagMa(iMA(NULL,0,1,0,MODE_SMA,Price,i),Length,alphas,0,i);
      double medias = iNoLagMa(iMA(NULL,0,1,0,MODE_SMA,Price,i+1),Length,alphas,0,i+1);
            
      //
      //
      //
      //
      //
      
      buffer1[i] = EMPTY_VALUE;
      buffer2[i] = EMPTY_VALUE;
      buffer3[i] = EMPTY_VALUE;
      buffer4[i] = EMPTY_VALUE;
      buffer5[i] = EMPTY_VALUE;
      buffer6[i] = EMPTY_VALUE;
      buffer7[i] = EMPTY_VALUE;
      buffer8[i] = EMPTY_VALUE;
         if (median < medias)
            {
              buffer1[i] = High[i];
              buffer2[i] = Low[i];
              if (Close[i]>Open[i]) { buffer3[i] = Close[i]; buffer4[i] = Open[i]; }  
              else                  { buffer4[i] = Close[i]; buffer3[i] = Open[i]; }  
            }                   
         if (median > medias)
            {
               buffer1[i] = Low[i];
               buffer2[i] = High[i];
               if (Close[i]<Open[i]) { buffer3[i] = Close[i]; buffer4[i] = Open[i]; }  
               else                  { buffer4[i] = Close[i]; buffer3[i] = Open[i]; }  
            }                   
         if (median == medias)
            {
               buffer5[i] = Low[i];
               buffer6[i] = High[i];
               buffer7[i] = Open[i];
               buffer8[i] = Close[i];
            }
   }
   return(0);
}


double values[][3];
double prices[][1];

#define Pi       3.14159265358979323846264338327950288
#define _length  0
#define _len     1
#define _weight  2

//
//
//
//
//

double iNoLagMa(double price, int length, double &alphasArray[], int forValue, int i)
{
   if (ArrayRange(prices,0) != Bars) ArrayResize(prices,Bars);
            int r = Bars-i-1;  prices[r][forValue]=price;
   if (length<3 || r<3) return(prices[r][forValue]);
   
   //
   //
   //
   //
   //
   
   if (ArrayRange(values,0)<(forValue+1) || values[forValue][_length] != length)
   {
      double Cycle = 4.0;
      double Coeff = 3.0*Pi;
      int    Phase = length-1;
      
      if (ArrayRange(values,0)<forValue+1) ArrayResize(values,forValue+1);

         values[forValue][_length] = length;
         values[forValue][_len]    = length*4 + Phase;  
         values[forValue][_weight] = 0;  
         ArrayResize(alphasArray,values[forValue][_len]);

         for (int k=0; k<values[forValue][_len]-1; k++)
         {
            if (k<=Phase-1) 
                 double t = 1.0 * k/(Phase-1);
            else        t = 1.0 + (k-Phase+1)*(2.0*Cycle-1.0)/(Cycle*length-1.0); 
            double beta = MathCos(Pi*t);
            double g = 1.0/(Coeff*t+1); if (t <= 0.5 ) g = 1;
      
            alphasArray[k]             = g * beta;
            values[forValue][_weight] += alphasArray[k];
         }
   }
   
   //
   //
   //
   //
   //
   
   if (values[forValue][_weight]>0)
   {
      int    len = values[forValue][_len];
      double sum = 0;
           for (k=0; k < len-1; k++) sum += alphasArray[k]*prices[r-k][forValue];      
           return( sum / values[forValue][_weight]);
   }
   else return(0);           
}