//------------------------------------------------------------------
#property copyright "copyright mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  Orange
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_level1  0
#property strict

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame       = PERIOD_CURRENT;    // Time frame to use
extern int                Length          =  32;               // Velocity period
extern ENUM_APPLIED_PRICE Price           =  PRICE_CLOSE;      // Price to use
extern bool               alertsOn        = false;             // Turn alerts on
extern bool               alertsOnCurrent = true;              // Alerts on current (still opened) bar
extern bool               alertsMessage   = true;              // Show pop-up message
extern bool               alertsSound     = false;             // Play alert sound
extern bool               alertsEmail     = false;             // Send alert email
extern bool               alertsPush      = false;             // Send alert push notification

//
//
//
//
//

double vel[];
double velda[];
double veldb[];
double trend[];

string indicatorFileName;
bool   returnBars;


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,vel);   SetIndexDrawBegin(0,Length+3);
   SetIndexBuffer(1,velda); SetIndexDrawBegin(1,Length+3);
   SetIndexBuffer(2,veldb); SetIndexDrawBegin(2,Length+3);
   SetIndexBuffer(3,trend);
   
      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame==-99);
      TimeFrame         = MathMax(TimeFrame,_Period);
   IndicatorShortName(timeFrameToString(TimeFrame)+" velocity ("+(string)Length+")");
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars)  { vel[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame==_Period)
   {
      if (trend[limit]==-1) CleanPoint(limit,velda,veldb);
      for(int i=limit; i>=0; i--)
      {
         vel[i]    = iVelocity(iMA(NULL,0,1,0,MODE_SMA,Price,i),Length,i);
         velda[i]  = EMPTY_VALUE;
         veldb[i]  = EMPTY_VALUE;
         if (i<Bars-1)
         {
            trend[i]  = trend[i+1];
               if (vel[i]>vel[i+1]) trend[i] =  1;
               if (vel[i]<vel[i+1]) trend[i] = -1;
               if (trend[i]==-1) PlotPoint(i,velda,veldb,vel);
         }               
      }
      manageAlerts();
      return(0);
   }        
   
   //
   //
   //
   //
   //

   limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   if (trend[limit]==-1) CleanPoint(limit,velda,veldb);
   for(int i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         vel[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Price,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsPush,0,y);
         velda[i] = EMPTY_VALUE;
         veldb[i] = EMPTY_VALUE;
         if (i<Bars-1)
         {
            trend[i] = trend[i+1];
               if (vel[i]>vel[i+1]) trend[i] =  1;
               if (vel[i]<vel[i+1]) trend[i] = -1;
               if (trend[i]==-1) PlotPoint(i,velda,veldb,vel);
         }               
   }
   return(0);
               
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"up");
         if (trend[whichBar] ==-1) doAlert(whichBar,"down");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(Period())+" velocity slope changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"velocity "),message);
          if (alertsPush)    SendNotification(message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}
  
//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

double prices[];
double iVelocity(double price, double length, int i)
{
   if (ArraySize(prices)!=Bars) ArrayResize(prices,Bars); i=Bars-i-1;
   
      prices[i] = price;
      double suma = 0.0, sumwa=0;
      double sumb = 0.0, sumwb=0;

      for(int k=0; k<length && (i-k)>=0; k++)
      {
         double weight = length-k;
            suma  += prices[i-k] * weight;
            sumb  += prices[i-k] * weight * weight;
            sumwa += weight;
            sumwb += weight*weight;
      }
   return(sumb/sumwb-suma/sumwa);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}
void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>Bars-3) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i]; first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] = from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                          second[i] = EMPTY_VALUE; }
}